# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "program4xi.py">
#<abstract4xi abstract = "program management"/>
#<refer4xi reference = "Programs"/>
#<verify4xi verification = "10" target = "program4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API                
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Program4Xi',                         # ACK 5.6     p132  

            'add2programwithbinary4xi',           # ACK 5.6.1   p132            
            'add2programwithsource4xi',           # ACK 5.6.1   p133  
                                
            'build2program4xi',                   # ACK 5.6.2   p137      

            'compile2program4xi',                 # ACK 5.6.3   p139            
            'create2programwithsource4xi',        # ACK 5.6.1   p132 
            'create2programwithbinary4xi',        # ACK 5.6.1   p133 
            'create2programwithbuiltinkernels4xi',# NACK 5.6.1  p135   
                       
            'delete2programwithbinary4xi',        # ACK  
            'delete2programwithsource4xi',        # ACK               

            'get2programinfo4xi',                 # ACK 5.6.7   p150 
            'get2programbuildinfo4xi',            # NACK 5.6.7  p153
            
            'link2program4xi',                    # ACK 5.6.3   p142                          
            'release2program4xi',                 # ACK 5.6.1   p136                                         
            'retain2program4xi',                  # ACK 5.6.1   p136
 
            'set2programwithsource4xi',           # ACK
            'set2programwithbinary4xi',           # ACK            
            'set2programcallback4xi',             # ACK 
                              
            'trace2program4xi',                   # ACK
            'unload2compiler4xi'                  # NACK 5.6.6  p149 
          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi


# -------------------------------------------------------------------------------------------------
# Image modules of devices                           
# -------------------------------------------------------------------------------------------------
from apu2program4xi import APU2Program4Xi                                                             
from bpu2program4xi import BPU2Program4Xi
from cpu2program4xi import CPU2Program4Xi
from dpu2program4xi import DPU2Program4Xi
from epu2program4xi import EPU2Program4Xi
from fpu2program4xi import FPU2Program4Xi
from gpu2program4xi import GPU2Program4Xi
from hpu2program4xi import HPU2Program4Xi
from ipu2program4xi import IPU2Program4Xi
from jpu2program4xi import JPU2Program4Xi
from kpu2program4xi import KPU2Program4Xi
from lpu2program4xi import LPU2Program4Xi
from mpu2program4xi import MPU2Program4Xi
from npu2program4xi import NPU2Program4Xi
from opu2program4xi import OPU2Program4Xi
from ppu2program4xi import PPU2Program4Xi
from qpu2program4xi import QPU2Program4Xi
from rpu2program4xi import RPU2Program4Xi
from spu2program4xi import SPU2Program4Xi
from tpu2program4xi import TPU2Program4Xi
from upu2program4xi import UPU2Program4Xi
from vpu2program4xi import VPU2Program4Xi
from xpu2program4xi import XPU2Program4Xi
from wpu2program4xi import WPU2Program4Xi
from ypu2program4xi import YPU2Program4Xi
from zpu2program4xi import ZPU2Program4Xi

from apu2program4xi import add2programwithbinary4apu                                                            
from bpu2program4xi import add2programwithbinary4bpu
from cpu2program4xi import add2programwithbinary4cpu
from dpu2program4xi import add2programwithbinary4dpu
from epu2program4xi import add2programwithbinary4epu
from fpu2program4xi import add2programwithbinary4fpu
from gpu2program4xi import add2programwithbinary4gpu
from hpu2program4xi import add2programwithbinary4hpu
from ipu2program4xi import add2programwithbinary4ipu
from jpu2program4xi import add2programwithbinary4jpu
from kpu2program4xi import add2programwithbinary4kpu
from lpu2program4xi import add2programwithbinary4lpu
from mpu2program4xi import add2programwithbinary4mpu
from npu2program4xi import add2programwithbinary4npu
from opu2program4xi import add2programwithbinary4opu
from ppu2program4xi import add2programwithbinary4ppu
from qpu2program4xi import add2programwithbinary4qpu
from rpu2program4xi import add2programwithbinary4rpu
from spu2program4xi import add2programwithbinary4spu
from tpu2program4xi import add2programwithbinary4tpu
from upu2program4xi import add2programwithbinary4upu
from vpu2program4xi import add2programwithbinary4vpu
from xpu2program4xi import add2programwithbinary4xpu
from wpu2program4xi import add2programwithbinary4wpu
from ypu2program4xi import add2programwithbinary4ypu
from zpu2program4xi import add2programwithbinary4zpu

from apu2program4xi import add2programwithsource4apu                                                            
from bpu2program4xi import add2programwithsource4bpu
from cpu2program4xi import add2programwithsource4cpu
from dpu2program4xi import add2programwithsource4dpu
from epu2program4xi import add2programwithsource4epu
from fpu2program4xi import add2programwithsource4fpu
from gpu2program4xi import add2programwithsource4gpu
from hpu2program4xi import add2programwithsource4hpu
from ipu2program4xi import add2programwithsource4ipu
from jpu2program4xi import add2programwithsource4jpu
from kpu2program4xi import add2programwithsource4kpu
from lpu2program4xi import add2programwithsource4lpu
from mpu2program4xi import add2programwithsource4mpu
from npu2program4xi import add2programwithsource4npu
from opu2program4xi import add2programwithsource4opu
from ppu2program4xi import add2programwithsource4ppu
from qpu2program4xi import add2programwithsource4qpu
from rpu2program4xi import add2programwithsource4rpu
from spu2program4xi import add2programwithsource4spu
from tpu2program4xi import add2programwithsource4tpu
from upu2program4xi import add2programwithsource4upu
from vpu2program4xi import add2programwithsource4vpu
from xpu2program4xi import add2programwithsource4xpu
from wpu2program4xi import add2programwithsource4wpu
from ypu2program4xi import add2programwithsource4ypu
from zpu2program4xi import add2programwithsource4zpu

from apu2program4xi import build2program4apu                                                            
from bpu2program4xi import build2program4bpu
from cpu2program4xi import build2program4cpu
from dpu2program4xi import build2program4dpu
from epu2program4xi import build2program4epu
from fpu2program4xi import build2program4fpu
from gpu2program4xi import build2program4gpu
from hpu2program4xi import build2program4hpu
from ipu2program4xi import build2program4ipu
from jpu2program4xi import build2program4jpu
from kpu2program4xi import build2program4kpu
from lpu2program4xi import build2program4lpu
from mpu2program4xi import build2program4mpu
from npu2program4xi import build2program4npu
from opu2program4xi import build2program4opu
from ppu2program4xi import build2program4ppu
from qpu2program4xi import build2program4qpu
from rpu2program4xi import build2program4rpu
from spu2program4xi import build2program4spu
from tpu2program4xi import build2program4tpu
from upu2program4xi import build2program4upu
from vpu2program4xi import build2program4vpu
from xpu2program4xi import build2program4xpu
from wpu2program4xi import build2program4wpu
from ypu2program4xi import build2program4ypu
from zpu2program4xi import build2program4zpu

from apu2program4xi import compile2program4apu                                                            
from bpu2program4xi import compile2program4bpu
from cpu2program4xi import compile2program4cpu
from dpu2program4xi import compile2program4dpu
from epu2program4xi import compile2program4epu
from fpu2program4xi import compile2program4fpu
from gpu2program4xi import compile2program4gpu
from hpu2program4xi import compile2program4hpu
from ipu2program4xi import compile2program4ipu
from jpu2program4xi import compile2program4jpu
from kpu2program4xi import compile2program4kpu
from lpu2program4xi import compile2program4lpu
from mpu2program4xi import compile2program4mpu
from npu2program4xi import compile2program4npu
from opu2program4xi import compile2program4opu
from ppu2program4xi import compile2program4ppu
from qpu2program4xi import compile2program4qpu
from rpu2program4xi import compile2program4rpu
from spu2program4xi import compile2program4spu
from tpu2program4xi import compile2program4tpu
from upu2program4xi import compile2program4upu
from vpu2program4xi import compile2program4vpu
from xpu2program4xi import compile2program4xpu
from wpu2program4xi import compile2program4wpu
from ypu2program4xi import compile2program4ypu
from zpu2program4xi import compile2program4zpu

from apu2program4xi import create2programwithsource4apu                                                            
from bpu2program4xi import create2programwithsource4bpu
from cpu2program4xi import create2programwithsource4cpu
from dpu2program4xi import create2programwithsource4dpu
from epu2program4xi import create2programwithsource4epu
from fpu2program4xi import create2programwithsource4fpu
from gpu2program4xi import create2programwithsource4gpu
from hpu2program4xi import create2programwithsource4hpu
from ipu2program4xi import create2programwithsource4ipu
from jpu2program4xi import create2programwithsource4jpu
from kpu2program4xi import create2programwithsource4kpu
from lpu2program4xi import create2programwithsource4lpu
from mpu2program4xi import create2programwithsource4mpu
from npu2program4xi import create2programwithsource4npu
from opu2program4xi import create2programwithsource4opu
from ppu2program4xi import create2programwithsource4ppu
from qpu2program4xi import create2programwithsource4qpu
from rpu2program4xi import create2programwithsource4rpu
from spu2program4xi import create2programwithsource4spu
from tpu2program4xi import create2programwithsource4tpu
from upu2program4xi import create2programwithsource4upu
from vpu2program4xi import create2programwithsource4vpu
from xpu2program4xi import create2programwithsource4xpu
from wpu2program4xi import create2programwithsource4wpu
from ypu2program4xi import create2programwithsource4ypu
from zpu2program4xi import create2programwithsource4zpu

from apu2program4xi import create2programwithbinary4apu                                                            
from bpu2program4xi import create2programwithbinary4bpu
from cpu2program4xi import create2programwithbinary4cpu
from dpu2program4xi import create2programwithbinary4dpu
from epu2program4xi import create2programwithbinary4epu
from fpu2program4xi import create2programwithbinary4fpu
from gpu2program4xi import create2programwithbinary4gpu
from hpu2program4xi import create2programwithbinary4hpu
from ipu2program4xi import create2programwithbinary4ipu
from jpu2program4xi import create2programwithbinary4jpu
from kpu2program4xi import create2programwithbinary4kpu
from lpu2program4xi import create2programwithbinary4lpu
from mpu2program4xi import create2programwithbinary4mpu
from npu2program4xi import create2programwithbinary4npu
from opu2program4xi import create2programwithbinary4opu
from ppu2program4xi import create2programwithbinary4ppu
from qpu2program4xi import create2programwithbinary4qpu
from rpu2program4xi import create2programwithbinary4rpu
from spu2program4xi import create2programwithbinary4spu
from tpu2program4xi import create2programwithbinary4tpu
from upu2program4xi import create2programwithbinary4upu
from vpu2program4xi import create2programwithbinary4vpu
from xpu2program4xi import create2programwithbinary4xpu
from wpu2program4xi import create2programwithbinary4wpu
from ypu2program4xi import create2programwithbinary4ypu
from zpu2program4xi import create2programwithbinary4zpu

from apu2program4xi import delete2programwithbinary4apu                                                            
from bpu2program4xi import delete2programwithbinary4bpu
from cpu2program4xi import delete2programwithbinary4cpu
from dpu2program4xi import delete2programwithbinary4dpu
from epu2program4xi import delete2programwithbinary4epu
from fpu2program4xi import delete2programwithbinary4fpu
from gpu2program4xi import delete2programwithbinary4gpu
from hpu2program4xi import delete2programwithbinary4hpu
from ipu2program4xi import delete2programwithbinary4ipu
from jpu2program4xi import delete2programwithbinary4jpu
from kpu2program4xi import delete2programwithbinary4kpu
from lpu2program4xi import delete2programwithbinary4lpu
from mpu2program4xi import delete2programwithbinary4mpu
from npu2program4xi import delete2programwithbinary4npu
from opu2program4xi import delete2programwithbinary4opu
from ppu2program4xi import delete2programwithbinary4ppu
from qpu2program4xi import delete2programwithbinary4qpu
from rpu2program4xi import delete2programwithbinary4rpu
from spu2program4xi import delete2programwithbinary4spu
from tpu2program4xi import delete2programwithbinary4tpu
from upu2program4xi import delete2programwithbinary4upu
from vpu2program4xi import delete2programwithbinary4vpu
from xpu2program4xi import delete2programwithbinary4xpu
from wpu2program4xi import delete2programwithbinary4wpu
from ypu2program4xi import delete2programwithbinary4ypu
from zpu2program4xi import delete2programwithbinary4zpu

from apu2program4xi import delete2programwithsource4apu                                                            
from bpu2program4xi import delete2programwithsource4bpu
from cpu2program4xi import delete2programwithsource4cpu
from dpu2program4xi import delete2programwithsource4dpu
from epu2program4xi import delete2programwithsource4epu
from fpu2program4xi import delete2programwithsource4fpu
from gpu2program4xi import delete2programwithsource4gpu
from hpu2program4xi import delete2programwithsource4hpu
from ipu2program4xi import delete2programwithsource4ipu
from jpu2program4xi import delete2programwithsource4jpu
from kpu2program4xi import delete2programwithsource4kpu
from lpu2program4xi import delete2programwithsource4lpu
from mpu2program4xi import delete2programwithsource4mpu
from npu2program4xi import delete2programwithsource4npu
from opu2program4xi import delete2programwithsource4opu
from ppu2program4xi import delete2programwithsource4ppu
from qpu2program4xi import delete2programwithsource4qpu
from rpu2program4xi import delete2programwithsource4rpu
from spu2program4xi import delete2programwithsource4spu
from tpu2program4xi import delete2programwithsource4tpu
from upu2program4xi import delete2programwithsource4upu
from vpu2program4xi import delete2programwithsource4vpu
from xpu2program4xi import delete2programwithsource4xpu
from wpu2program4xi import delete2programwithsource4wpu
from ypu2program4xi import delete2programwithsource4ypu
from zpu2program4xi import delete2programwithsource4zpu

from apu2program4xi import get2programinfo4apu                                                            
from bpu2program4xi import get2programinfo4bpu
from cpu2program4xi import get2programinfo4cpu
from dpu2program4xi import get2programinfo4dpu
from epu2program4xi import get2programinfo4epu
from fpu2program4xi import get2programinfo4fpu
from gpu2program4xi import get2programinfo4gpu
from hpu2program4xi import get2programinfo4hpu
from ipu2program4xi import get2programinfo4ipu
from jpu2program4xi import get2programinfo4jpu
from kpu2program4xi import get2programinfo4kpu
from lpu2program4xi import get2programinfo4lpu
from mpu2program4xi import get2programinfo4mpu
from npu2program4xi import get2programinfo4npu
from opu2program4xi import get2programinfo4opu
from ppu2program4xi import get2programinfo4ppu
from qpu2program4xi import get2programinfo4qpu
from rpu2program4xi import get2programinfo4rpu
from spu2program4xi import get2programinfo4spu
from tpu2program4xi import get2programinfo4tpu
from upu2program4xi import get2programinfo4upu
from vpu2program4xi import get2programinfo4vpu
from xpu2program4xi import get2programinfo4xpu
from wpu2program4xi import get2programinfo4wpu
from ypu2program4xi import get2programinfo4ypu
from zpu2program4xi import get2programinfo4zpu

from apu2program4xi import link2program4apu                                                            
from bpu2program4xi import link2program4bpu
from cpu2program4xi import link2program4cpu
from dpu2program4xi import link2program4dpu
from epu2program4xi import link2program4epu
from fpu2program4xi import link2program4fpu
from gpu2program4xi import link2program4gpu
from hpu2program4xi import link2program4hpu
from ipu2program4xi import link2program4ipu
from jpu2program4xi import link2program4jpu
from kpu2program4xi import link2program4kpu
from lpu2program4xi import link2program4lpu
from mpu2program4xi import link2program4mpu
from npu2program4xi import link2program4npu
from opu2program4xi import link2program4opu
from ppu2program4xi import link2program4ppu
from qpu2program4xi import link2program4qpu
from rpu2program4xi import link2program4rpu
from spu2program4xi import link2program4spu
from tpu2program4xi import link2program4tpu
from upu2program4xi import link2program4upu
from vpu2program4xi import link2program4vpu
from xpu2program4xi import link2program4xpu
from wpu2program4xi import link2program4wpu
from ypu2program4xi import link2program4ypu
from zpu2program4xi import link2program4zpu

from apu2program4xi import release2program4apu                                                            
from bpu2program4xi import release2program4bpu
from cpu2program4xi import release2program4cpu
from dpu2program4xi import release2program4dpu
from epu2program4xi import release2program4epu
from fpu2program4xi import release2program4fpu
from gpu2program4xi import release2program4gpu
from hpu2program4xi import release2program4hpu
from ipu2program4xi import release2program4ipu
from jpu2program4xi import release2program4jpu
from kpu2program4xi import release2program4kpu
from lpu2program4xi import release2program4lpu
from mpu2program4xi import release2program4mpu
from npu2program4xi import release2program4npu
from opu2program4xi import release2program4opu
from ppu2program4xi import release2program4ppu
from qpu2program4xi import release2program4qpu
from rpu2program4xi import release2program4rpu
from spu2program4xi import release2program4spu
from tpu2program4xi import release2program4tpu
from upu2program4xi import release2program4upu
from vpu2program4xi import release2program4vpu
from xpu2program4xi import release2program4xpu
from wpu2program4xi import release2program4wpu
from ypu2program4xi import release2program4ypu
from zpu2program4xi import release2program4zpu

from apu2program4xi import retain2program4apu                                                            
from bpu2program4xi import retain2program4bpu
from cpu2program4xi import retain2program4cpu
from dpu2program4xi import retain2program4dpu
from epu2program4xi import retain2program4epu
from fpu2program4xi import retain2program4fpu
from gpu2program4xi import retain2program4gpu
from hpu2program4xi import retain2program4hpu
from ipu2program4xi import retain2program4ipu
from jpu2program4xi import retain2program4jpu
from kpu2program4xi import retain2program4kpu
from lpu2program4xi import retain2program4lpu
from mpu2program4xi import retain2program4mpu
from npu2program4xi import retain2program4npu
from opu2program4xi import retain2program4opu
from ppu2program4xi import retain2program4ppu
from qpu2program4xi import retain2program4qpu
from rpu2program4xi import retain2program4rpu
from spu2program4xi import retain2program4spu
from tpu2program4xi import retain2program4tpu
from upu2program4xi import retain2program4upu
from vpu2program4xi import retain2program4vpu
from xpu2program4xi import retain2program4xpu
from wpu2program4xi import retain2program4wpu
from ypu2program4xi import retain2program4ypu
from zpu2program4xi import retain2program4zpu

from apu2program4xi import set2programwithsource4apu                                                            
from bpu2program4xi import set2programwithsource4bpu
from cpu2program4xi import set2programwithsource4cpu
from dpu2program4xi import set2programwithsource4dpu
from epu2program4xi import set2programwithsource4epu
from fpu2program4xi import set2programwithsource4fpu
from gpu2program4xi import set2programwithsource4gpu
from hpu2program4xi import set2programwithsource4hpu
from ipu2program4xi import set2programwithsource4ipu
from jpu2program4xi import set2programwithsource4jpu
from kpu2program4xi import set2programwithsource4kpu
from lpu2program4xi import set2programwithsource4lpu
from mpu2program4xi import set2programwithsource4mpu
from npu2program4xi import set2programwithsource4npu
from opu2program4xi import set2programwithsource4opu
from ppu2program4xi import set2programwithsource4ppu
from qpu2program4xi import set2programwithsource4qpu
from rpu2program4xi import set2programwithsource4rpu
from spu2program4xi import set2programwithsource4spu
from tpu2program4xi import set2programwithsource4tpu
from upu2program4xi import set2programwithsource4upu
from vpu2program4xi import set2programwithsource4vpu
from xpu2program4xi import set2programwithsource4xpu
from wpu2program4xi import set2programwithsource4wpu
from ypu2program4xi import set2programwithsource4ypu
from zpu2program4xi import set2programwithsource4zpu

from apu2program4xi import set2programwithbinary4apu                                                            
from bpu2program4xi import set2programwithbinary4bpu
from cpu2program4xi import set2programwithbinary4cpu
from dpu2program4xi import set2programwithbinary4dpu
from epu2program4xi import set2programwithbinary4epu
from fpu2program4xi import set2programwithbinary4fpu
from gpu2program4xi import set2programwithbinary4gpu
from hpu2program4xi import set2programwithbinary4hpu
from ipu2program4xi import set2programwithbinary4ipu
from jpu2program4xi import set2programwithbinary4jpu
from kpu2program4xi import set2programwithbinary4kpu
from lpu2program4xi import set2programwithbinary4lpu
from mpu2program4xi import set2programwithbinary4mpu
from npu2program4xi import set2programwithbinary4npu
from opu2program4xi import set2programwithbinary4opu
from ppu2program4xi import set2programwithbinary4ppu
from qpu2program4xi import set2programwithbinary4qpu
from rpu2program4xi import set2programwithbinary4rpu
from spu2program4xi import set2programwithbinary4spu
from tpu2program4xi import set2programwithbinary4tpu
from upu2program4xi import set2programwithbinary4upu
from vpu2program4xi import set2programwithbinary4vpu
from xpu2program4xi import set2programwithbinary4xpu
from wpu2program4xi import set2programwithbinary4wpu
from ypu2program4xi import set2programwithbinary4ypu
from zpu2program4xi import set2programwithbinary4zpu

from apu2program4xi import set2programcallback4apu                                                            
from bpu2program4xi import set2programcallback4bpu
from cpu2program4xi import set2programcallback4cpu
from dpu2program4xi import set2programcallback4dpu
from epu2program4xi import set2programcallback4epu
from fpu2program4xi import set2programcallback4fpu
from gpu2program4xi import set2programcallback4gpu
from hpu2program4xi import set2programcallback4hpu
from ipu2program4xi import set2programcallback4ipu
from jpu2program4xi import set2programcallback4jpu
from kpu2program4xi import set2programcallback4kpu
from lpu2program4xi import set2programcallback4lpu
from mpu2program4xi import set2programcallback4mpu
from npu2program4xi import set2programcallback4npu
from opu2program4xi import set2programcallback4opu
from ppu2program4xi import set2programcallback4ppu
from qpu2program4xi import set2programcallback4qpu
from rpu2program4xi import set2programcallback4rpu
from spu2program4xi import set2programcallback4spu
from tpu2program4xi import set2programcallback4tpu
from upu2program4xi import set2programcallback4upu
from vpu2program4xi import set2programcallback4vpu
from xpu2program4xi import set2programcallback4xpu
from wpu2program4xi import set2programcallback4wpu
from ypu2program4xi import set2programcallback4ypu
from zpu2program4xi import set2programcallback4zpu

from apu2program4xi import trace2program4apu                                                            
from bpu2program4xi import trace2program4bpu
from cpu2program4xi import trace2program4cpu
from dpu2program4xi import trace2program4dpu
from epu2program4xi import trace2program4epu
from fpu2program4xi import trace2program4fpu
from gpu2program4xi import trace2program4gpu
from hpu2program4xi import trace2program4hpu
from ipu2program4xi import trace2program4ipu
from jpu2program4xi import trace2program4jpu
from kpu2program4xi import trace2program4kpu
from lpu2program4xi import trace2program4lpu
from mpu2program4xi import trace2program4mpu
from npu2program4xi import trace2program4npu
from opu2program4xi import trace2program4opu
from ppu2program4xi import trace2program4ppu
from qpu2program4xi import trace2program4qpu
from rpu2program4xi import trace2program4rpu
from spu2program4xi import trace2program4spu
from tpu2program4xi import trace2program4tpu
from upu2program4xi import trace2program4upu
from vpu2program4xi import trace2program4vpu
from xpu2program4xi import trace2program4xpu
from wpu2program4xi import trace2program4wpu
from ypu2program4xi import trace2program4ypu
from zpu2program4xi import trace2program4zpu

# -------------------------------------------------------------------------------------------------
# Buffer module                           
# -------------------------------------------------------------------------------------------------
from buffer4xi import Buffer4Xi
from buffer4xi import create2buffer4xi
from buffer4xi import create2subbuffer4xi
from buffer4xi import get2bufferinfo4xi
from buffer4xi import release2buffer4xi
from buffer4xi import retain2buffer4xi
from buffer4xi import set2buffer4xi


# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from commandqueue4xi import CommandQueue4Xi
from commandqueue4xi import create2commandqueue4xi 
from commandqueue4xi import flush2commandqueue4xi
from commandqueue4xi import finish2commandqueue4xi
from commandqueue4xi import get2commandqueueinfo4xi
from commandqueue4xi import release2commandqueue4xi
from commandqueue4xi import retain2commandqueue4xi
from commandqueue4xi import set2commandqueue4xi


# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi 
from context4xi import create2context4xi
from context4xi import get2context4xi
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi
from device4xi import init2device4xi 
from device4xi import set2device4xi
from device4xi import get2device4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from event4xi import Event4Xi


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global program4xi                                                      # PROGRAMS

global programtrace4xi                                                 # TRACE

global info2program4xi                                                 # PROGRAM INFORMATION

global platform2xi                                                     # PLATFORM
global device2xi                                                       # DEVICE
global context2xi                                                      # CONTEXT

        
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
program4xi = {}                                                        # PROGRAMS
programtrace4xi = {}                                                   # TRACE
info2program4xi = {}                                                   # PROGRAM INFORMATION

platform2xi = {}                                                       # PLATFORM
device2xi   = {}                                                       # DEVICE
context2xi  = {}                                                       # CONTEXT

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2program4xi" usage = "  
#
#   print('(Step 15A/25) OF PROGRAM4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
#   try:                               
#       task4trace2program  = {}
#       for key2pu in keys2pu:
#           task4trace2program[key2pu]  = {}
#       response4trace2program = trace2program4xi(task4trace2program)  
#       key2response = response4trace2program.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4trace2program[key2response] )
#           # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4apu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2program4apu', 'METHOD': 'trace2program4apu'}
#           # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4gpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2program4gpu', 'METHOD': 'trace2program4gpu'}
#           # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4xpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2program4xpu', 'METHOD': 'trace2program4xpu'}
#           # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4zpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2program4zpu', 'METHOD': 'trace2program4zpu'}                                                                                                  
#   except:
#       print('(Step 15Z1/25) OF PROGRAM4XI5TEST *** FAILED TO TRACE XI: ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def trace2program4xi(task4trace2xi=None):  

    '''
    creates callback to program4xi
    '''

    global programtrace4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    debug = False
    
    class2print = "trace2program4xi" 
    method2print = "trace2program4xi"

    message2print = "{(Step 1A/33) started" + "; trace2program4xi-started: " + str(trace2program4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2xi-to-trace2program4xi: " + str(task4trace2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    programtrace4xi = {}                                                                                             # INITIALIZES TO EMPTY DICTIONARY
      
      
    if task4trace2xi is None:
        keys2task = None    
    else:
        try:
            keys2task = task4trace2xi.keys()
        except:
            keys2task = None   
    if debug is True:
       print("{(Step 1C/33) of trace2program4xi - keys2task: ", sorted(keys2task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2task:
            message2print = "{(Step A/33) passing" + "; task-passing-to-trace2program4apu: " + str(task4trace2xi['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            programtrace4xi ['APU']  = trace2program4apu()                                                      
             
            message2print = "{(Step A1/33) set" + "; apu-program-trace-set-by-trace2program4apu to: " + str(programtrace4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of trace2program4xi - set trace4xi of APU program to: ", programtrace4xi ['APU'])
            
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-trace2program4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2task:
            message2print = "{(Step B/33) passing" + "; task-passing-to-trace2program4bpu: " + str(task4trace2xi['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['BPU']  = trace2program4bpu()                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-program-trace-set-by-trace2program4bpu to: " + str(programtrace4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-trace2program4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2task:
            message2print = "{(Step C/33) passing" + "; task-passing-to-trace2program4cpu: " + str(task4trace2xi['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['CPU']  = trace2program4cpu()                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-program-trace-set-by-trace2program4cpu to: " + str(programtrace4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-trace2program4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2task:
            message2print = "{(Step D/33) passing" + "; task-passing-to-trace2program4dpu: " + str(task4trace2xi['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['DPU']  = trace2program4dpu()                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-program-trace-set-by-trace2program4dpu to: " + str(programtrace4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-trace2program4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2task:
            message2print = "{(Step E/33) passing" + "; task-passing-to-trace2program4epu: " + str(task4trace2xi['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['EPU']  = trace2program4epu()                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-program-trace-set-by-trace2program4epu to: " + str(programtrace4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-trace2program4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2task:
            message2print = "{(Step F/33) passing" + "; task-passing-to-trace2program4fpu: " + str(task4trace2xi['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['FPU']  = trace2program4fpu()                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-program-trace-set-by-trace2program4fpu to: " + str(programtrace4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-trace2program4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2task:
            message2print = "{(Step G/33) passing" + "; task-passing-to-trace2program4gpu: " + str(task4trace2xi['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['GPU']  = trace2program4gpu()                                                      # 
         
            message2print = "{(Step G1/33) set" + "; gpu-program-trace-set-by-trace2program4gpu to: " + str(programtrace4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-trace2program4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2task:
            message2print = "{(Step H/33) passing" + "; task-passing-to-trace2program4hpu: " + str(task4trace2xi['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['HPU']  = trace2program4hpu()                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-program-trace-set-by-trace2program4hpu to: " + str(programtrace4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-trace2program4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2task:
            message2print = "{(Step I/33) passing" + "; task-passing-to-trace2program4ipu: " + str(task4trace2xi['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['IPU']  = trace2program4ipu()                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-program-trace-set-by-trace2program4ipu to: " + str(programtrace4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-trace2program4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2task:
            message2print = "{(Step J/33) passing" + "; task-passing-to-trace2program4jpu: " + str(task4trace2xi['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['JPU']  = trace2program4jpu()                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-program-trace-set-by-trace2program4jpu to: " + str(programtrace4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-trace2program4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2task:
            message2print = "{(Step K/33) passing" + "; task-passing-to-trace2program4kpu: " + str(task4trace2xi['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['KPU']  = trace2program4kpu()                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-program-trace-set-by-trace2program4kpu to: " + str(programtrace4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-trace2program4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2task:
            message2print = "{(Step L/33) passing" + "; task-passing-to-trace2program4lpu: " + str(task4trace2xi['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['LPU']  = trace2program4lpu()                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-program-trace-set-by-trace2program4lpu to: " + str(programtrace4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-trace2program4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2task:
            message2print = "{(Step M/33) passing" + "; task-passing-to-trace2program4mpu: " + str(task4trace2xi['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['MPU']  = trace2program4mpu()                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-program-trace-set-by-trace2program4mpu to: " + str(programtrace4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-trace2program4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2task:
            message2print = "{(Step N/33) passing" + "; task-passing-to-trace2program4npu: " + str(task4trace2xi['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['NPU']  = trace2program4npu()                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-program-trace-set-by-trace2program4npu to: " + str(programtrace4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-trace2program4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2task:
            message2print = "{(Step O/33) passing" + "; task-passing-to-trace2program4opu: " + str(task4trace2xi['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['OPU']  = trace2program4opu()                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-program-trace-set-by-trace2program4opu to: " + str(programtrace4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-trace2program4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2task:
            message2print = "{(Step P/33) passing" + "; task-passing-to-trace2program4ppu: " + str(task4trace2xi['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['PPU']  = trace2program4ppu()                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-program-trace-set-by-trace2program4ppu to: " + str(programtrace4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-trace2program4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2task:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-trace2program4qpu: " + str(task4trace2xi['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['QPU']  = trace2program4qpu()                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-program-trace-set-by-trace2program4qpu to: " + str(programtrace4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-trace2program4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2task:
            message2print = "{(Step R/33) passing" + "; task-passing-to-trace2program4rpu: " + str(task4trace2xi['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['RPU']  = trace2program4rpu()                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-program-trace-set-by-trace2program4rpu to: " + str(programtrace4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-trace2program4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2task:
            message2print = "{(Step S/33) passing" + "; task-passing-to-trace2program4spu: " + str(task4trace2xi['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['SPU']  = trace2program4spu()                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-program-trace-set-by-trace2program4spu to: " + str(programtrace4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-trace2program4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2task:
            message2print = "{(Step T/33) passing" + "; task-passing-to-trace2program4tpu: " + str(task4trace2xi['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['TPU']  = trace2program4tpu()                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-program-trace-set-by-trace2program4tpu to: " + str(programtrace4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-trace2program4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2task:
            message2print = "{(Step U/33) passing" + "; task-passing-to-trace2program4upu: " + str(task4trace2xi['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['UPU']  = trace2program4upu()                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-program-trace-set-by-trace2program4upu to: " + str(programtrace4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-trace2program4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2task:
            message2print = "{(Step V/33) passing" + "; task-passing-to-trace2program4vpu: " + str(task4trace2xi['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['VPU']  = trace2program4vpu()                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-program-trace-set-by-trace2program4vpu to: " + str(programtrace4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-trace2program4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2task:
            message2print = "{(Step W/33) passing" + "; task-passing-to-trace2program4wpu: " + str(task4trace2xi['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['WPU']  = trace2program4wpu()                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-program-trace-set-by-trace2program4wpu to: " + str(programtrace4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-trace2program4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2task:
            message2print = "{(Step X/33) passing" + "; task-passing-to-trace2program4xpu: " + str(task4trace2xi['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['XPU']  = trace2program4xpu()                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-program-trace-set-by-trace2program4xpu to: " + str(programtrace4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of trace2program4xi - set trace4xi of XPU program to: ", programtrace4xi ['XPU'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-trace2program4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2task:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-trace2program4ypu: " + str(task4trace2xi['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['YPU']  = trace2program4ypu()                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-program-trace-set-by-trace2program4ypu to: " + str(programtrace4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-trace2program4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2task:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-trace2program4zpu: " + str(task4trace2xi['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            programtrace4xi ['ZPU']  = trace2program4zpu()                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-program-trace-set-by-trace2program4zpu to: " + str(programtrace4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of trace2program4xi - set trace4xi of ZPU program to: ", programtrace4xi ['ZPU'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-trace2program4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    print("{(Step 33/33) of trace2program4xi programtrace4xi - RETURNING : ") 
    if debug is True:
        for key2task in keys2task:
            print(key2task, programtrace4xi[key2task])
            # 
                
    message2print = "{(Step 33/33) returning" + "; programtrace4xi-returning-by-trace2program4xi: " + str(programtrace4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #  
    
    return programtrace4xi


#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2programcallback4xi" usage = " 
#
#   print('(Step 14B/700) OF PROGRAM4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF XI DEVICE ', time4xi())     
#   try:                               
#       task4callback2program  = {}
#       for key2pu in keys2pu:
#           task4callback2program[key2pu]  = {}
#       response4setcallback2program = set2programcallback4xi(task4callback2program) 
#       key2response = response4setcallback2program.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4setcallback2program[key2response])
#           # APU  :  <function trace2program4apu at 0x00000000043F1C48>
#           # ...
#           # ZPU  :  <function trace2program4zpu at 0x00000000058610C8>
#                                                                                                     
#   except:
#       print('(Step 14Z2/700) OF PROGRAM4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF XI DEVICE ', time4xi())
#
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2programcallback4xi(task4set2programcallback=None):

    '''
    registers callback function to program4xi
    '''
    global program4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = False
    
    class2print = "set2programcallback4xi"
    method2print = "set2programcallback4xi"

    message2print = "{(Step 1A/33) started" + "; set2programcallback4xi-started: " + str(set2programcallback4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4programset2xi-to-set2programcallback4xi: " + str(task4set2programcallback) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
            
    code2ack  = ' '
    code2nack = ' '
    if program4xi is None:
        program4xi = create2programwithsource4xi()                                                                            
                                
        message2print = "{(Step 1C/33) set" + "; program4xi-set-by-set2programcallback4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
    
        
    if task4set2programcallback is None:
        keys2task = None    
    else:
        try:
            keys2task = task4set2programcallback.keys()
        except:
            keys2task = None   
    if debug is True:
       print("{(Step 1C/33) of set2programcallback4xi - keys2task: ", sorted(keys2task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2task:
            message2print = "{(Step A/33) passing" + "; task-passing-to-set2programcallback4apu: " + str(task4set2programcallback['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            program4xi ['APU'] ['CALLBACK'] = set2programcallback4apu()                                                      # 
             
            message2print = "{(Step A1/33) set" + "; apu-program-set-by-set2programcallback4apu to: " + str(program4xi ['APU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of set2programcallback4xi - set callback4xi of APU program to: ", program4xi ['APU'] ['CALLBACK'])
            
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2programcallback4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2task:
            message2print = "{(Step B/33) passing" + "; task-passing-to-set2programcallback4bpu: " + str(task4set2programcallback['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['BPU'] ['CALLBACK'] = set2programcallback4bpu()                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-program-set-by-set2programcallback4bpu to: " + str(program4xi ['BPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2programcallback4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2task:
            message2print = "{(Step C/33) passing" + "; task-passing-to-set2programcallback4cpu: " + str(task4set2programcallback['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['CPU'] ['CALLBACK'] = set2programcallback4cpu()                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-program-set-by-set2programcallback4cpu to: " + str(program4xi ['CPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2programcallback4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2task:
            message2print = "{(Step D/33) passing" + "; task-passing-to-set2programcallback4dpu: " + str(task4set2programcallback['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['DPU'] ['CALLBACK'] = set2programcallback4dpu()                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-program-set-by-set2programcallback4dpu to: " + str(program4xi ['DPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2programcallback4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2task:
            message2print = "{(Step E/33) passing" + "; task-passing-to-set2programcallback4epu: " + str(task4set2programcallback['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['EPU'] ['CALLBACK'] = set2programcallback4epu()                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-program-set-by-set2programcallback4epu to: " + str(program4xi ['EPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2programcallback4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2task:
            message2print = "{(Step F/33) passing" + "; task-passing-to-set2programcallback4fpu: " + str(task4set2programcallback['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['FPU'] ['CALLBACK'] = set2programcallback4fpu()                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-program-set-by-set2programcallback4fpu to: " + str(program4xi ['FPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2programcallback4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2task:
            message2print = "{(Step G/33) passing" + "; task-passing-to-set2programcallback4gpu: " + str(task4set2programcallback['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['GPU'] ['CALLBACK'] = set2programcallback4gpu()                                                      # 
         
            message2print = "{(Step G1/33) set" + "; gpu-program-set-by-set2programcallback4gpu to: " + str(program4xi ['GPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2programcallback4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2task:
            message2print = "{(Step H/33) passing" + "; task-passing-to-set2programcallback4hpu: " + str(task4set2programcallback['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['HPU'] ['CALLBACK'] = set2programcallback4hpu()                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-program-set-by-set2programcallback4hpu to: " + str(program4xi ['HPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2programcallback4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2task:
            message2print = "{(Step I/33) passing" + "; task-passing-to-set2programcallback4ipu: " + str(task4set2programcallback['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['IPU'] ['CALLBACK'] = set2programcallback4ipu()                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-program-set-by-set2programcallback4ipu to: " + str(program4xi ['IPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2programcallback4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2task:
            message2print = "{(Step J/33) passing" + "; task-passing-to-set2programcallback4jpu: " + str(task4set2programcallback['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['JPU'] ['CALLBACK'] = set2programcallback4jpu()                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-program-set-by-set2programcallback4jpu to: " + str(program4xi ['JPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2programcallback4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2task:
            message2print = "{(Step K/33) passing" + "; task-passing-to-set2programcallback4kpu: " + str(task4set2programcallback['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['KPU'] ['CALLBACK'] = set2programcallback4kpu()                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-program-set-by-set2programcallback4kpu to: " + str(program4xi ['KPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2programcallback4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2task:
            message2print = "{(Step L/33) passing" + "; task-passing-to-set2programcallback4lpu: " + str(task4set2programcallback['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['LPU'] ['CALLBACK'] = set2programcallback4lpu()                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-program-set-by-set2programcallback4lpu to: " + str(program4xi ['LPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2programcallback4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2task:
            message2print = "{(Step M/33) passing" + "; task-passing-to-set2programcallback4mpu: " + str(task4set2programcallback['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['MPU'] ['CALLBACK'] = set2programcallback4mpu()                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-program-set-by-set2programcallback4mpu to: " + str(program4xi ['MPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2programcallback4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2task:
            message2print = "{(Step N/33) passing" + "; task-passing-to-set2programcallback4npu: " + str(task4set2programcallback['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['NPU'] ['CALLBACK'] = set2programcallback4npu()                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-program-set-by-set2programcallback4npu to: " + str(program4xi ['NPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2programcallback4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2task:
            message2print = "{(Step O/33) passing" + "; task-passing-to-set2programcallback4opu: " + str(task4set2programcallback['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['OPU'] ['CALLBACK'] = set2programcallback4opu()                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-program-set-by-set2programcallback4opu to: " + str(program4xi ['OPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2programcallback4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2task:
            message2print = "{(Step P/33) passing" + "; task-passing-to-set2programcallback4ppu: " + str(task4set2programcallback['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['PPU'] ['CALLBACK'] = set2programcallback4ppu()                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-program-set-by-set2programcallback4ppu to: " + str(program4xi ['PPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2programcallback4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2task:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-set2programcallback4qpu: " + str(task4set2programcallback['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['QPU'] ['CALLBACK'] = set2programcallback4qpu()                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-program-set-by-set2programcallback4qpu to: " + str(program4xi ['QPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2programcallback4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2task:
            message2print = "{(Step R/33) passing" + "; task-passing-to-set2programcallback4rpu: " + str(task4set2programcallback['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['RPU'] ['CALLBACK'] = set2programcallback4rpu()                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-program-set-by-set2programcallback4rpu to: " + str(program4xi ['RPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2programcallback4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2task:
            message2print = "{(Step S/33) passing" + "; task-passing-to-set2programcallback4spu: " + str(task4set2programcallback['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['SPU'] ['CALLBACK'] = set2programcallback4spu()                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-program-set-by-set2programcallback4spu to: " + str(program4xi ['SPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2programcallback4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2task:
            message2print = "{(Step T/33) passing" + "; task-passing-to-set2programcallback4tpu: " + str(task4set2programcallback['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['TPU'] ['CALLBACK'] = set2programcallback4tpu()                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-program-set-by-set2programcallback4tpu to: " + str(program4xi ['TPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2programcallback4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2task:
            message2print = "{(Step U/33) passing" + "; task-passing-to-set2programcallback4upu: " + str(task4set2programcallback['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['UPU'] ['CALLBACK'] = set2programcallback4upu()                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-program-set-by-set2programcallback4upu to: " + str(program4xi ['UPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2programcallback4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2task:
            message2print = "{(Step V/33) passing" + "; task-passing-to-set2programcallback4vpu: " + str(task4set2programcallback['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['VPU'] ['CALLBACK'] = set2programcallback4vpu()                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-program-set-by-set2programcallback4vpu to: " + str(program4xi ['VPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2programcallback4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2task:
            message2print = "{(Step W/33) passing" + "; task-passing-to-set2programcallback4wpu: " + str(task4set2programcallback['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['WPU'] ['CALLBACK'] = set2programcallback4wpu()                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-program-set-by-set2programcallback4wpu to: " + str(program4xi ['WPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2programcallback4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2task:
            message2print = "{(Step X/33) passing" + "; task-passing-to-set2programcallback4xpu: " + str(task4set2programcallback['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['XPU'] ['CALLBACK'] = set2programcallback4xpu()                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-program-set-by-set2programcallback4xpu to: " + str(program4xi ['XPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of set2programcallback4xi - set callback4xi of XPU program to: ", program4xi ['XPU'] ['CALLBACK'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2programcallback4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2task:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-set2programcallback4ypu: " + str(task4set2programcallback['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['YPU'] ['CALLBACK'] = set2programcallback4ypu()                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-program-set-by-set2programcallback4ypu to: " + str(program4xi ['YPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2programcallback4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2task:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-set2programcallback4zpu: " + str(task4set2programcallback['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            program4xi ['ZPU'] ['CALLBACK'] = set2programcallback4zpu()                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-program-set-by-set2programcallback4zpu to: " + str(program4xi ['ZPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of set2programcallback4xi - set callback4xi of ZPU program to: ", program4xi ['ZPU'] ['CALLBACK'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2programcallback4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set2programcallback4xi - RETURNING PROGRAM4XI: ", program4xi)
    
    message2print = "{(Step 33/33) returning" + "; program4xi-returning-by-set2programcallback4xi: " + str(program4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return program4xi
         
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2programwithsource4xi" usage = "
#1     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM WITH SOURCE FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create2programwithsource = create2programwithsource4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - CREATED PROGRAM4XI ', time4xi())
#       keys2response = response4create2programwithsource.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2programwithsource[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM WITH SOURCE FOR XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def create2programwithsource4xi(task4create2programwithsource=None):

    '''
    creates program with source for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = False
        
    class2print = "create2programwithsource4xi" 
    method2print = "create2programwithsource4xi"

    message2print = "{(Step 1A/70) started" + "; create2programwithsource4xi-started: " + str(create2programwithsource4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2programwithsource-to-create2programwithsource4xi: " + str(task4create2programwithsource) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2programwithsource is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2programwithsource-try-by-create2programwithsource4xi: " + str(task4create2programwithsource)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            program4xi = {}
            message2print = "{(Step 3A/33) initialized" + "; program4xi-initialized-by-create2programwithsource4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #                                     
            program4xi['APU'] = create2programwithsource4apu()                                                                        
            program4xi['BPU'] = create2programwithsource4bpu()   
            program4xi['CPU'] = create2programwithsource4cpu()   
            program4xi['DPU'] = create2programwithsource4dpu()   
            program4xi['EPU'] = create2programwithsource4epu()   
            program4xi['FPU'] = create2programwithsource4fpu()   
            program4xi['GPU'] = create2programwithsource4gpu()   
            program4xi['HPU'] = create2programwithsource4hpu()   
            program4xi['IPU'] = create2programwithsource4ipu()   
            program4xi['JPU'] = create2programwithsource4jpu()   
            program4xi['KPU'] = create2programwithsource4kpu()   
            program4xi['LPU'] = create2programwithsource4lpu()   
            program4xi['MPU'] = create2programwithsource4mpu()   
            program4xi['NPU'] = create2programwithsource4npu()   
            program4xi['OPU'] = create2programwithsource4opu()   
            program4xi['PPU'] = create2programwithsource4ppu()   
            program4xi['QPU'] = create2programwithsource4qpu()   
            program4xi['RPU'] = create2programwithsource4rpu()   
            program4xi['SPU'] = create2programwithsource4spu()   
            program4xi['TPU'] = create2programwithsource4tpu()   
            program4xi['UPU'] = create2programwithsource4upu()   
            program4xi['VPU'] = create2programwithsource4vpu()   
            program4xi['XPU'] = create2programwithsource4xpu()   
            program4xi['WPU'] = create2programwithsource4wpu()   
            program4xi['YPU'] = create2programwithsource4ypu()   
            program4xi['ZPU'] = create2programwithsource4zpu()   
            
            message2print = "{(Step 3A/33) created" + "; program4xi-created-by-create2programwithsource4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            program4xi['APU'] = create2programwithsource4apu(task4create2programwithsource['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2programwithsource4xi to: " + str(program4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            program4xi['BPU'] = create2programwithsource4bpu(task4create2programwithsource['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            program4xi['CPU'] = create2programwithsource4cpu(task4create2programwithsource['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            program4xi['DPU'] = create2programwithsource4dpu(task4create2programwithsource['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            program4xi['EPU'] = create2programwithsource4epu(task4create2programwithsource['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2programwithsource4xi to: " + str(program4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            program4xi['FPU'] = create2programwithsource4fpu(task4create2programwithsource['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            program4xi['GPU'] = create2programwithsource4gpu(task4create2programwithsource['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            program4xi['HPU'] = create2programwithsource4hpu(task4create2programwithsource['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            program4xi['IPU'] = create2programwithsource4ipu(task4create2programwithsource['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2programwithsource4xi to: " + str(program4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            program4xi['JPU'] = create2programwithsource4jpu(task4create2programwithsource['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            program4xi['KPU'] = create2programwithsource4kpu(task4create2programwithsource['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            program4xi['LPU'] = create2programwithsource4lpu(task4create2programwithsource['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            program4xi['MPU'] = create2programwithsource4mpu(task4create2programwithsource['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            program4xi['NPU'] = create2programwithsource4npu(task4create2programwithsource['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2programwithsource4xi to: " + str(program4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            program4xi['OPU'] = create2programwithsource4opu(task4create2programwithsource['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2programwithsource4xi to: " + str(program4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            program4xi['PPU'] = create2programwithsource4ppu(task4create2programwithsource['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2programwithsource4xi to: " + str(program4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            program4xi['QPU'] = create2programwithsource4qpu(task4create2programwithsource['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            program4xi['RPU'] = create2programwithsource4rpu(task4create2programwithsource['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            program4xi['SPU'] = create2programwithsource4spu(task4create2programwithsource['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2programwithsource4xi to: " + str(program4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            program4xi['TPU'] = create2programwithsource4tpu(task4create2programwithsource['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            program4xi['UPU'] = create2programwithsource4upu(task4create2programwithsource['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2programwithsource4xi to: " + str(program4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            program4xi['VPU'] = create2programwithsource4vpu(task4create2programwithsource['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            program4xi['WPU'] = create2programwithsource4wpu(task4create2programwithsource['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            program4xi['XPU'] = create2programwithsource4xpu(task4create2programwithsource['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            program4xi['YPU'] = create2programwithsource4ypu(task4create2programwithsource['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2programwithsource4xi to: " + str(program4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            program4xi['ZPU'] = create2programwithsource4zpu(task4create2programwithsource['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2programwithsource4xi to: " + str(program4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create2programwithsource4xi - RETURNING PROGRAM4XI: ", program4xi)
            
    message2print = "{(Step 33/33) returning" + "; program4xi-returning-by-create2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return program4xi
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2programwithbinary4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM WITH BINARY FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create2programwithbinary = create2programwithbinary4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - CREATED PROGRAM4XI ', time4xi())
#       keys2response = response4create2programwithbinary.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2programwithbinary[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM WITH BINARY FOR XI *** ', time4xi())
#    
#">

# ------------------------------------------------------------------------------------------------- 

def create2programwithbinary4xi(task4create2programwithbinary=None):

    '''
    creates program with binary for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = False
        
    class2print = "create2programwithbinary4xi" 
    method2print = "create2programwithbinary4xi"

    message2print = "{(Step 1A/70) started" + "; create2programwithbinary4xi-started: " + str(create2programwithbinary4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2programwithbinary-to-create2programwithbinary4xi: " + str(task4create2programwithbinary) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2programwithbinary is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2programwithbinary-try-by-create2programwithbinary4xi: " + str(task4create2programwithbinary)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            program4xi = {}
            message2print = "{(Step 3A/33) initialized" + "; program4xi-initialized-by-create2programwithbinary4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #                                     
            program4xi['APU'] = create2programwithbinary4apu()                                                                        
            program4xi['BPU'] = create2programwithbinary4bpu()   
            program4xi['CPU'] = create2programwithbinary4cpu()   
            program4xi['DPU'] = create2programwithbinary4dpu()   
            program4xi['EPU'] = create2programwithbinary4epu()   
            program4xi['FPU'] = create2programwithbinary4fpu()   
            program4xi['GPU'] = create2programwithbinary4gpu()   
            program4xi['HPU'] = create2programwithbinary4hpu()   
            program4xi['IPU'] = create2programwithbinary4ipu()   
            program4xi['JPU'] = create2programwithbinary4jpu()   
            program4xi['KPU'] = create2programwithbinary4kpu()   
            program4xi['LPU'] = create2programwithbinary4lpu()   
            program4xi['MPU'] = create2programwithbinary4mpu()   
            program4xi['NPU'] = create2programwithbinary4npu()   
            program4xi['OPU'] = create2programwithbinary4opu()   
            program4xi['PPU'] = create2programwithbinary4ppu()   
            program4xi['QPU'] = create2programwithbinary4qpu()   
            program4xi['RPU'] = create2programwithbinary4rpu()   
            program4xi['SPU'] = create2programwithbinary4spu()   
            program4xi['TPU'] = create2programwithbinary4tpu()   
            program4xi['UPU'] = create2programwithbinary4upu()   
            program4xi['VPU'] = create2programwithbinary4vpu()   
            program4xi['XPU'] = create2programwithbinary4xpu()   
            program4xi['WPU'] = create2programwithbinary4wpu()   
            program4xi['YPU'] = create2programwithbinary4ypu()   
            program4xi['ZPU'] = create2programwithbinary4zpu()   
            
            message2print = "{(Step 3A/33) created" + "; program4xi-created-by-create2programwithbinary4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            program4xi['APU'] = create2programwithbinary4apu(task4create2programwithbinary['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            program4xi['BPU'] = create2programwithbinary4bpu(task4create2programwithbinary['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            program4xi['CPU'] = create2programwithbinary4cpu(task4create2programwithbinary['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            program4xi['DPU'] = create2programwithbinary4dpu(task4create2programwithbinary['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            program4xi['EPU'] = create2programwithbinary4epu(task4create2programwithbinary['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            program4xi['FPU'] = create2programwithbinary4fpu(task4create2programwithbinary['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            program4xi['GPU'] = create2programwithbinary4gpu(task4create2programwithbinary['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            program4xi['HPU'] = create2programwithbinary4hpu(task4create2programwithbinary['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            program4xi['IPU'] = create2programwithbinary4ipu(task4create2programwithbinary['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            program4xi['JPU'] = create2programwithbinary4jpu(task4create2programwithbinary['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            program4xi['KPU'] = create2programwithbinary4kpu(task4create2programwithbinary['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            program4xi['LPU'] = create2programwithbinary4lpu(task4create2programwithbinary['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            program4xi['MPU'] = create2programwithbinary4mpu(task4create2programwithbinary['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            program4xi['NPU'] = create2programwithbinary4npu(task4create2programwithbinary['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            program4xi['OPU'] = create2programwithbinary4opu(task4create2programwithbinary['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            program4xi['PPU'] = create2programwithbinary4ppu(task4create2programwithbinary['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            program4xi['QPU'] = create2programwithbinary4qpu(task4create2programwithbinary['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            program4xi['RPU'] = create2programwithbinary4rpu(task4create2programwithbinary['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            program4xi['SPU'] = create2programwithbinary4spu(task4create2programwithbinary['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            program4xi['TPU'] = create2programwithbinary4tpu(task4create2programwithbinary['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            program4xi['UPU'] = create2programwithbinary4upu(task4create2programwithbinary['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            program4xi['VPU'] = create2programwithbinary4vpu(task4create2programwithbinary['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            program4xi['WPU'] = create2programwithbinary4wpu(task4create2programwithbinary['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            program4xi['XPU'] = create2programwithbinary4xpu(task4create2programwithbinary['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            program4xi['YPU'] = create2programwithbinary4ypu(task4create2programwithbinary['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            program4xi['ZPU'] = create2programwithbinary4zpu(task4create2programwithbinary['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create2programwithbinary4xi - RETURNING PROGRAM4XI: ", program4xi)
            
    message2print = "{(Step 33/33) returning" + "; program4xi-returning-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return program4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2programwithbinary4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM WITH BINARY FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create2programwithbinary = create2programwithbinary4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - CREATED PROGRAM4XI ', time4xi())
#       keys2response = response4create2programwithbinary.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2programwithbinary[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM WITH BINARY FOR XI *** ', time4xi())
#    
#">

# -------------------------------------------------------------------------------------------------   
def create2programwithbinary4xi(task4create2programwithbinary=None):

    '''
    creates program with binary for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = False
        
    class2print = "create2programwithbinary4xi" 
    method2print = "create2programwithbinary4xi"

    message2print = "{(Step 1A/70) started" + "; create2programwithbinary4xi-started: " + str(create2programwithbinary4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2programwithbinary-to-create2programwithbinary4xi: " + str(task4create2programwithbinary) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2programwithbinary is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2programwithbinary-try-by-create2programwithbinary4xi: " + str(task4create2programwithbinary)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            program4xi = {}
            message2print = "{(Step 3A/33) initialized" + "; program4xi-initialized-by-create2programwithbinary4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #              
            program4xi['APU'] = create2programwithbinary4apu()                                                                        
            program4xi['BPU'] = create2programwithbinary4bpu()   
            program4xi['CPU'] = create2programwithbinary4cpu()   
            program4xi['DPU'] = create2programwithbinary4dpu()   
            program4xi['EPU'] = create2programwithbinary4epu()   
            program4xi['FPU'] = create2programwithbinary4fpu()   
            program4xi['GPU'] = create2programwithbinary4gpu()   
            program4xi['HPU'] = create2programwithbinary4hpu()   
            program4xi['IPU'] = create2programwithbinary4ipu()   
            program4xi['JPU'] = create2programwithbinary4jpu()   
            program4xi['KPU'] = create2programwithbinary4kpu()   
            program4xi['LPU'] = create2programwithbinary4lpu()   
            program4xi['MPU'] = create2programwithbinary4mpu()   
            program4xi['NPU'] = create2programwithbinary4npu()   
            program4xi['OPU'] = create2programwithbinary4opu()   
            program4xi['PPU'] = create2programwithbinary4ppu()   
            program4xi['QPU'] = create2programwithbinary4qpu()   
            program4xi['RPU'] = create2programwithbinary4rpu()   
            program4xi['SPU'] = create2programwithbinary4spu()   
            program4xi['TPU'] = create2programwithbinary4tpu()   
            program4xi['UPU'] = create2programwithbinary4upu()   
            program4xi['VPU'] = create2programwithbinary4vpu()   
            program4xi['XPU'] = create2programwithbinary4xpu()   
            program4xi['WPU'] = create2programwithbinary4wpu()   
            program4xi['YPU'] = create2programwithbinary4ypu()   
            program4xi['ZPU'] = create2programwithbinary4zpu()   
            
            message2print = "{(Step 3B/33) created" + "; program4xi-created-by-create2programwithbinary4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3B-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            program4xi['APU'] = create2programwithbinary4apu(task4create2programwithbinary['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            program4xi['BPU'] = create2programwithbinary4bpu(task4create2programwithbinary['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            program4xi['CPU'] = create2programwithbinary4cpu(task4create2programwithbinary['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            program4xi['DPU'] = create2programwithbinary4dpu(task4create2programwithbinary['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            program4xi['EPU'] = create2programwithbinary4epu(task4create2programwithbinary['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            program4xi['FPU'] = create2programwithbinary4fpu(task4create2programwithbinary['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            program4xi['GPU'] = create2programwithbinary4gpu(task4create2programwithbinary['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            program4xi['HPU'] = create2programwithbinary4hpu(task4create2programwithbinary['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            program4xi['IPU'] = create2programwithbinary4ipu(task4create2programwithbinary['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            program4xi['JPU'] = create2programwithbinary4jpu(task4create2programwithbinary['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            program4xi['KPU'] = create2programwithbinary4kpu(task4create2programwithbinary['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            program4xi['LPU'] = create2programwithbinary4lpu(task4create2programwithbinary['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            program4xi['MPU'] = create2programwithbinary4mpu(task4create2programwithbinary['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            program4xi['NPU'] = create2programwithbinary4npu(task4create2programwithbinary['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            program4xi['OPU'] = create2programwithbinary4opu(task4create2programwithbinary['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            program4xi['PPU'] = create2programwithbinary4ppu(task4create2programwithbinary['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            program4xi['QPU'] = create2programwithbinary4qpu(task4create2programwithbinary['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            program4xi['RPU'] = create2programwithbinary4rpu(task4create2programwithbinary['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            program4xi['SPU'] = create2programwithbinary4spu(task4create2programwithbinary['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            program4xi['TPU'] = create2programwithbinary4tpu(task4create2programwithbinary['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            program4xi['UPU'] = create2programwithbinary4upu(task4create2programwithbinary['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            program4xi['VPU'] = create2programwithbinary4vpu(task4create2programwithbinary['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            program4xi['WPU'] = create2programwithbinary4wpu(task4create2programwithbinary['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            program4xi['XPU'] = create2programwithbinary4xpu(task4create2programwithbinary['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            program4xi['YPU'] = create2programwithbinary4ypu(task4create2programwithbinary['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            program4xi['ZPU'] = create2programwithbinary4zpu(task4create2programwithbinary['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2programwithbinary4xi to: " + str(program4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create2programwithbinary4xi - RETURNING PROGRAM4XI: ", program4xi)
            
    message2print = "{(Step 33/33) returning" + "; program4xi-returning-by-create2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return program4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2programwithbuiltinkernels4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM WITH BUILT IN KERNELS FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create2programwithbuiltinkernels = create2programwithbuiltinkernels4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - CREATED PROGRAM4XI ', time4xi())
#       keys2response = response4create2programwithbuiltinkernels.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2programwithbuiltinkernels[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM WITH BUILT IN KERNELS FOR XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def create2programwithbuiltinkernels4xi(task4create2programwithbuiltinkernels=None):

    '''
    creates program with built in kernels
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = False
        
    class2print = "create2programwithbuiltinkernels4xi" 
    method2print = "create2programwithbuiltinkernels4xi"

    message2print = "{(Step 1A/70) started" + "; create2programwithbuiltinkernels4xi-started: " + str(create2programwithbuiltinkernels4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2programwithbuiltinkernels-to-create2programwithbuiltinkernels4xi: " + str(task4create2programwithbuiltinkernels) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2programwithbuiltinkernels is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithbinary4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithbinary4xi()
            code2ack  = code2ack + '1Z-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2programwithbuiltinkernels-try-by-create2programwithbuiltinkernels4xi: " + str(task4create2programwithbuiltinkernels)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            program4xi = {} 
            program4xi['APU'] = create2programwithbuiltinkernels4apu()                                                                        
            program4xi['BPU'] = create2programwithbuiltinkernels4bpu()   
            program4xi['CPU'] = create2programwithbuiltinkernels4cpu()   
            program4xi['DPU'] = create2programwithbuiltinkernels4dpu()   
            program4xi['EPU'] = create2programwithbuiltinkernels4epu()   
            program4xi['FPU'] = create2programwithbuiltinkernels4fpu()   
            program4xi['GPU'] = create2programwithbuiltinkernels4gpu()   
            program4xi['HPU'] = create2programwithbuiltinkernels4hpu()   
            program4xi['IPU'] = create2programwithbuiltinkernels4ipu()   
            program4xi['JPU'] = create2programwithbuiltinkernels4jpu()   
            program4xi['KPU'] = create2programwithbuiltinkernels4kpu()   
            program4xi['LPU'] = create2programwithbuiltinkernels4lpu()   
            program4xi['MPU'] = create2programwithbuiltinkernels4mpu()   
            program4xi['NPU'] = create2programwithbuiltinkernels4npu()   
            program4xi['OPU'] = create2programwithbuiltinkernels4opu()   
            program4xi['PPU'] = create2programwithbuiltinkernels4ppu()   
            program4xi['QPU'] = create2programwithbuiltinkernels4qpu()   
            program4xi['RPU'] = create2programwithbuiltinkernels4rpu()   
            program4xi['SPU'] = create2programwithbuiltinkernels4spu()   
            program4xi['TPU'] = create2programwithbuiltinkernels4tpu()   
            program4xi['UPU'] = create2programwithbuiltinkernels4upu()   
            program4xi['VPU'] = create2programwithbuiltinkernels4vpu()   
            program4xi['XPU'] = create2programwithbuiltinkernels4xpu()   
            program4xi['WPU'] = create2programwithbuiltinkernels4wpu()   
            program4xi['YPU'] = create2programwithbuiltinkernels4ypu()   
            program4xi['ZPU'] = create2programwithbuiltinkernels4zpu()   
            
            message2print = "{(Step 3A/33) initialized" + "; program4xi-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            program4xi['APU'] = create2programwithbuiltinkernels4apu(task4create2programwithbuiltinkernels['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            program4xi['BPU'] = create2programwithbuiltinkernels4bpu(task4create2programwithbuiltinkernels['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            program4xi['CPU'] = create2programwithbuiltinkernels4cpu(task4create2programwithbuiltinkernels['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            program4xi['DPU'] = create2programwithbuiltinkernels4dpu(task4create2programwithbuiltinkernels['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            program4xi['EPU'] = create2programwithbuiltinkernels4epu(task4create2programwithbuiltinkernels['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            program4xi['FPU'] = create2programwithbuiltinkernels4fpu(task4create2programwithbuiltinkernels['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            program4xi['GPU'] = create2programwithbuiltinkernels4gpu(task4create2programwithbuiltinkernels['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            program4xi['HPU'] = create2programwithbuiltinkernels4hpu(task4create2programwithbuiltinkernels['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            program4xi['IPU'] = create2programwithbuiltinkernels4ipu(task4create2programwithbuiltinkernels['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            program4xi['JPU'] = create2programwithbuiltinkernels4jpu(task4create2programwithbuiltinkernels['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            program4xi['KPU'] = create2programwithbuiltinkernels4kpu(task4create2programwithbuiltinkernels['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            program4xi['LPU'] = create2programwithbuiltinkernels4lpu(task4create2programwithbuiltinkernels['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            program4xi['MPU'] = create2programwithbuiltinkernels4mpu(task4create2programwithbuiltinkernels['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            program4xi['NPU'] = create2programwithbuiltinkernels4npu(task4create2programwithbuiltinkernels['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            program4xi['OPU'] = create2programwithbuiltinkernels4opu(task4create2programwithbuiltinkernels['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            program4xi['PPU'] = create2programwithbuiltinkernels4ppu(task4create2programwithbuiltinkernels['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            program4xi['QPU'] = create2programwithbuiltinkernels4qpu(task4create2programwithbuiltinkernels['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            program4xi['RPU'] = create2programwithbuiltinkernels4rpu(task4create2programwithbuiltinkernels['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            program4xi['SPU'] = create2programwithbuiltinkernels4spu(task4create2programwithbuiltinkernels['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            program4xi['TPU'] = create2programwithbuiltinkernels4tpu(task4create2programwithbuiltinkernels['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            program4xi['UPU'] = create2programwithbuiltinkernels4upu(task4create2programwithbuiltinkernels['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            program4xi['VPU'] = create2programwithbuiltinkernels4vpu(task4create2programwithbuiltinkernels['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            program4xi['WPU'] = create2programwithbuiltinkernels4wpu(task4create2programwithbuiltinkernels['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            program4xi['XPU'] = create2programwithbuiltinkernels4xpu(task4create2programwithbuiltinkernels['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            program4xi['YPU'] = create2programwithbuiltinkernels4ypu(task4create2programwithbuiltinkernels['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            program4xi['ZPU'] = create2programwithbuiltinkernels4zpu(task4create2programwithbuiltinkernels['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2programwithbuiltinkernels4xi to: " + str(program4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create2programwithbuiltinkernels4xi - RETURNING PROGRAM4XI: ", program4xi)
            
    message2print = "{(Step 33/33) returning" + "; program4xi-returning-by-create2programwithbuiltinkernels4xi: " + str(program4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return program4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2programwithsource4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO SET PROGRAM WITH SOURCE FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4set2programwithsource = set2programwithsource4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - SET PROGRAM WITH SOURCE FOR XI ', time4xi())
#       keys2response = response4set2programwithsource.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4set2programwithsource[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO SET PROGRAM WITH SOURCE FOR XI *** ', time4xi())
#   
#">

# -------------------------------------------------------------------------------------------------   
def set2programwithsource4xi(task4set2programwithsource=None):

    '''
    sets program with source for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4set2pws = {}
        
    class2print = "set2programwithsource4xi" 
    method2print = "set2programwithsource4xi"

    message2print = "{(Step 1A/70) started" + "; set2programwithsource4xi-started: " + str(set2programwithsource4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4set2programwithsource-to-set2programwithsource4xi: " + str(task4set2programwithsource) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4set2programwithsource is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithsource4xi()
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithsource4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4set2programwithsource-try-by-set2programwithsource4xi: " + str(task4set2programwithsource)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4set2pws['APU'] = set2programwithsource4apu()                                                                        
            response4set2pws['BPU'] = set2programwithsource4bpu()   
            response4set2pws['CPU'] = set2programwithsource4cpu()   
            response4set2pws['DPU'] = set2programwithsource4dpu()   
            response4set2pws['EPU'] = set2programwithsource4epu()   
            response4set2pws['FPU'] = set2programwithsource4fpu()   
            response4set2pws['GPU'] = set2programwithsource4gpu()   
            response4set2pws['HPU'] = set2programwithsource4hpu()   
            response4set2pws['IPU'] = set2programwithsource4ipu()   
            response4set2pws['JPU'] = set2programwithsource4jpu()   
            response4set2pws['KPU'] = set2programwithsource4kpu()   
            response4set2pws['LPU'] = set2programwithsource4lpu()   
            response4set2pws['MPU'] = set2programwithsource4mpu()   
            response4set2pws['NPU'] = set2programwithsource4npu()   
            response4set2pws['OPU'] = set2programwithsource4opu()   
            response4set2pws['PPU'] = set2programwithsource4ppu()   
            response4set2pws['QPU'] = set2programwithsource4qpu()   
            response4set2pws['RPU'] = set2programwithsource4rpu()   
            response4set2pws['SPU'] = set2programwithsource4spu()   
            response4set2pws['TPU'] = set2programwithsource4tpu()   
            response4set2pws['UPU'] = set2programwithsource4upu()   
            response4set2pws['VPU'] = set2programwithsource4vpu()   
            response4set2pws['XPU'] = set2programwithsource4xpu()   
            response4set2pws['WPU'] = set2programwithsource4wpu()   
            response4set2pws['YPU'] = set2programwithsource4ypu()   
            response4set2pws['ZPU'] = set2programwithsource4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-set2programwithsource4xi: " + str(response4set2pws)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['APU'] = set2programwithsource4apu(task4set2programwithsource['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-set2programwithsource4xi: " + str(response4set2pws['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['BPU'] = set2programwithsource4bpu(task4set2programwithsource['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-set2programwithsource4xi: " + str(response4set2pws['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['CPU'] = set2programwithsource4cpu(task4set2programwithsource['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-set2programwithsource4xi: " + str(response4set2pws['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['DPU'] = set2programwithsource4dpu(task4set2programwithsource['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-set2programwithsource4xi: " + str(response4set2pws['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['EPU'] = set2programwithsource4epu(task4set2programwithsource['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-set2programwithsource4xi: " + str(response4set2pws['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['FPU'] = set2programwithsource4fpu(task4set2programwithsource['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-set2programwithsource4xi: " + str(response4set2pws['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['GPU'] = set2programwithsource4gpu(task4set2programwithsource['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-set2programwithsource4xi: " + str(response4set2pws['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['HPU'] = set2programwithsource4hpu(task4set2programwithsource['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-set2programwithsource4xi: " + str(response4set2pws['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['IPU'] = set2programwithsource4ipu(task4set2programwithsource['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-set2programwithsource4xi: " + str(response4set2pws['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['JPU'] = set2programwithsource4jpu(task4set2programwithsource['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-set2programwithsource4xi: " + str(response4set2pws['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['KPU'] = set2programwithsource4kpu(task4set2programwithsource['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-set2programwithsource4xi: " + str(response4set2pws['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['LPU'] = set2programwithsource4lpu(task4set2programwithsource['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-set2programwithsource4xi: " + str(response4set2pws['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['MPU'] = set2programwithsource4mpu(task4set2programwithsource['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-set2programwithsource4xi: " + str(response4set2pws['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['NPU'] = set2programwithsource4npu(task4set2programwithsource['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-set2programwithsource4xi: " + str(response4set2pws['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['OPU'] = set2programwithsource4opu(task4set2programwithsource['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-set2programwithsource4xi: " + str(response4set2pws['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['PPU'] = set2programwithsource4ppu(task4set2programwithsource['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-set2programwithsource4xi: " + str(response4set2pws['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['QPU'] = set2programwithsource4qpu(task4set2programwithsource['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-set2programwithsource4xi: " + str(response4set2pws['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['RPU'] = set2programwithsource4rpu(task4set2programwithsource['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-set2programwithsource4xi: " + str(response4set2pws['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['SPU'] = set2programwithsource4spu(task4set2programwithsource['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-set2programwithsource4xi: " + str(response4set2pws['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['TPU'] = set2programwithsource4tpu(task4set2programwithsource['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-set2programwithsource4xi: " + str(response4set2pws['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['UPU'] = set2programwithsource4upu(task4set2programwithsource['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-set2programwithsource4xi: " + str(response4set2pws['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['VPU'] = set2programwithsource4vpu(task4set2programwithsource['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-set2programwithsource4xi: " + str(response4set2pws['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['WPU'] = set2programwithsource4wpu(task4set2programwithsource['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-set2programwithsource4xi: " + str(response4set2pws['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['XPU'] = set2programwithsource4xpu(task4set2programwithsource['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-set2programwithsource4xi: " + str(response4set2pws['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['YPU'] = set2programwithsource4ypu(task4set2programwithsource['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-set2programwithsource4xi: " + str(response4set2pws['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['ZPU'] = set2programwithsource4zpu(task4set2programwithsource['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-set2programwithsource4xi: " + str(response4set2pws['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set2programwithsource4xi - RETURNING response4set2pws: ", response4set2pws)
            
    message2print = "{(Step 33/33) returning" + "; response4set2pws-returning-by-set2programwithsource4xi: " + str(response4set2pws) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4set2pws
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2programwithbinary4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO SET PROGRAM WITH BINARY FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4set2programwithbinary = set2programwithbinary4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - SET PROGRAM WITH BINARY FOR XI ', time4xi())
#       keys2response = response4set2programwithbinary.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4set2programwithbinary[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO SET PROGRAM WITH BINARY FOR XI *** ', time4xi())
#   
#">

# -------------------------------------------------------------------------------------------------   
def set2programwithbinary4xi(task4set2programwithbinary=None):

    '''
    sets program with binary for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4set2pws = {}
         
    class2print = "set2programwithbinary4xi"  
    method2print = "set2programwithbinary4xi"

    message2print = "{(Step 1A/70) started" + "; set2programwithbinary4xi-started: " + str(set2programwithbinary4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function set2programwithbinary4xi at 0x00000000054E6AC8>
  
             
    message2print = "{(Step 1B/70) passed" + "; task4set2programwithbinary-to-set2programwithbinary4xi: " + str(task4set2programwithbinary) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'DPU': {'CODE2ERROR': 0, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005577B70> ...

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4set2programwithbinary is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithbinary4xi()
                message2print = "{(Step 1B/70) performed" + "; create2programwithbinary4xi-performed-by-set2programwithbinary4xi: " + str(create2programwithbinary4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                              
                # 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithbinary4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4set2programwithbinary-try-by-set2programwithbinary4xi: " + str(task4set2programwithbinary)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'DPU': {'CODE2ERROR': 0, 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000498AF98> ...
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4set2pws['APU'] = set2programwithbinary4apu()                                                                        
            response4set2pws['BPU'] = set2programwithbinary4bpu()   
            response4set2pws['CPU'] = set2programwithbinary4cpu()   
            response4set2pws['DPU'] = set2programwithbinary4dpu()   
            response4set2pws['EPU'] = set2programwithbinary4epu()   
            response4set2pws['FPU'] = set2programwithbinary4fpu()   
            response4set2pws['GPU'] = set2programwithbinary4gpu()   
            response4set2pws['HPU'] = set2programwithbinary4hpu()   
            response4set2pws['IPU'] = set2programwithbinary4ipu()   
            response4set2pws['JPU'] = set2programwithbinary4jpu()   
            response4set2pws['KPU'] = set2programwithbinary4kpu()   
            response4set2pws['LPU'] = set2programwithbinary4lpu()   
            response4set2pws['MPU'] = set2programwithbinary4mpu()   
            response4set2pws['NPU'] = set2programwithbinary4npu()   
            response4set2pws['OPU'] = set2programwithbinary4opu()   
            response4set2pws['PPU'] = set2programwithbinary4ppu()   
            response4set2pws['QPU'] = set2programwithbinary4qpu()   
            response4set2pws['RPU'] = set2programwithbinary4rpu()   
            response4set2pws['SPU'] = set2programwithbinary4spu()   
            response4set2pws['TPU'] = set2programwithbinary4tpu()   
            response4set2pws['UPU'] = set2programwithbinary4upu()   
            response4set2pws['VPU'] = set2programwithbinary4vpu()   
            response4set2pws['XPU'] = set2programwithbinary4xpu()   
            response4set2pws['WPU'] = set2programwithbinary4wpu()   
            response4set2pws['YPU'] = set2programwithbinary4ypu()   
            response4set2pws['ZPU'] = set2programwithbinary4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-set2programwithbinary4xi: " + str(response4set2pws)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try: 
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            message2print = "{(Step A/33) calling" + "; set2programwithbinary4apu-calling-by-set2programwithbinary4xi: " + str(set2programwithbinary4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function set2programwithbinary4apu at 0x0000000004786048>
            
            response4set2pws['APU'] = set2programwithbinary4apu(task4set2programwithbinary['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-set2programwithbinary4xi: " + str(response4set2pws['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; set2programwithbinary4apu-yielded-by-set2programwithbinary4xi: " + str(set2programwithbinary4apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['BPU'] = set2programwithbinary4bpu(task4set2programwithbinary['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['CPU'] = set2programwithbinary4cpu(task4set2programwithbinary['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['DPU'] = set2programwithbinary4dpu(task4set2programwithbinary['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['EPU'] = set2programwithbinary4epu(task4set2programwithbinary['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-set2programwithbinary4xi: " + str(response4set2pws['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['FPU'] = set2programwithbinary4fpu(task4set2programwithbinary['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['GPU'] = set2programwithbinary4gpu(task4set2programwithbinary['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['HPU'] = set2programwithbinary4hpu(task4set2programwithbinary['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['IPU'] = set2programwithbinary4ipu(task4set2programwithbinary['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-set2programwithbinary4xi: " + str(response4set2pws['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['JPU'] = set2programwithbinary4jpu(task4set2programwithbinary['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['KPU'] = set2programwithbinary4kpu(task4set2programwithbinary['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['LPU'] = set2programwithbinary4lpu(task4set2programwithbinary['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['MPU'] = set2programwithbinary4mpu(task4set2programwithbinary['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['NPU'] = set2programwithbinary4npu(task4set2programwithbinary['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-set2programwithbinary4xi: " + str(response4set2pws['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['OPU'] = set2programwithbinary4opu(task4set2programwithbinary['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-set2programwithbinary4xi: " + str(response4set2pws['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['PPU'] = set2programwithbinary4ppu(task4set2programwithbinary['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-set2programwithbinary4xi: " + str(response4set2pws['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['QPU'] = set2programwithbinary4qpu(task4set2programwithbinary['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['RPU'] = set2programwithbinary4rpu(task4set2programwithbinary['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['SPU'] = set2programwithbinary4spu(task4set2programwithbinary['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-set2programwithbinary4xi: " + str(response4set2pws['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['TPU'] = set2programwithbinary4tpu(task4set2programwithbinary['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['UPU'] = set2programwithbinary4upu(task4set2programwithbinary['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-set2programwithbinary4xi: " + str(response4set2pws['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['VPU'] = set2programwithbinary4vpu(task4set2programwithbinary['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['WPU'] = set2programwithbinary4wpu(task4set2programwithbinary['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['XPU'] = set2programwithbinary4xpu(task4set2programwithbinary['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['YPU'] = set2programwithbinary4ypu(task4set2programwithbinary['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-set2programwithbinary4xi: " + str(response4set2pws['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4set2pws['ZPU'] = set2programwithbinary4zpu(task4set2programwithbinary['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-set2programwithbinary4xi: " + str(response4set2pws['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set2programwithbinary4xi - RETURNING response4set2pws: ", response4set2pws)
            
    message2print = "{(Step 33/33) returning" + "; response4set2pws-returning-by-set2programwithbinary4xi: " + str(response4set2pws) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4set2pws
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2program4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO RELEASE PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4release2program = release2program4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - RELEASE XI ', time4xi())
#       keys2response = response4release2program.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4release2program[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO RELEASE PROGRAM OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def release2program4xi(task4release2program=None):

    '''
    release program of xi
    '''
    global program4xi
    global platform2xi
    global device2xi
    global context2xi 
                                                                                         
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4release2program = None
    keys2task4release = task4release2program.keys()     
    class2print = "release2program4xi" 
    method2print = "release2program4xi"

    message2print = "{(Step 1A/70) started" + "; release2program4xi-started: " + str(release2program4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4release2program-to-release2program4xi: " + str(task4release2program) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4release2program is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if response4release2program is None:                                                                                       
                response4release2program = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            response4release2program = create2programwithsource4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4release2program-try-by-release2program4xi: " + str(task4release2program)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4release2program = release2program4apu()                                                                        
            response4release2program = release2program4bpu()   
            response4release2program = release2program4cpu()   
            response4release2program = release2program4dpu()   
            response4release2program = release2program4epu()   
            response4release2program = release2program4fpu()   
            response4release2program = release2program4gpu()   
            response4release2program = release2program4hpu()   
            response4release2program = release2program4ipu()   
            response4release2program = release2program4jpu()   
            response4release2program = release2program4kpu()   
            response4release2program = release2program4lpu()   
            response4release2program = release2program4mpu()   
            response4release2program = release2program4npu()   
            response4release2program = release2program4opu()   
            response4release2program = release2program4ppu()   
            response4release2program = release2program4qpu()   
            response4release2program = release2program4rpu()   
            response4release2program = release2program4spu()   
            response4release2program = release2program4tpu()   
            response4release2program = release2program4upu()   
            response4release2program = release2program4vpu()   
            response4release2program = release2program4xpu()   
            response4release2program = release2program4wpu()   
            response4release2program = release2program4ypu()   
            response4release2program = release2program4zpu()   
            
            message2print = "{(Step 3A/33) set" + "; response4release2program-set-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; response4release2program-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        if 'APU' in keys2task4release:   
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response4release2program  = release2program4apu()
            
                message2print = "{(Step A/33) calculated" + "; apu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2task4release:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4bpu()
            
                message2print = "{(Step B/33) calculated" + "; bpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4cpu()
            
                message2print = "{(Step C/33) calculated" + "; cpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4dpu()
            
                message2print = "{(Step D/33) calculated" + "; dpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4epu()
            
                message2print = "{(Step E/33) calculated" + "; epu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4fpu()
            
                message2print = "{(Step F/33) calculated" + "; fpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4gpu()
            
                message2print = "{(Step G/33) calculated" + "; gpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4hpu()
            
                message2print = "{(Step H/33) calculated" + "; hpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4ipu()
            
                message2print = "{(Step I/33) calculated" + "; ipu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4jpu()
            
                message2print = "{(Step J/33) calculated" + "; jpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4kpu()
            
                message2print = "{(Step K/33) calculated" + "; kpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4lpu()
            
                message2print = "{(Step L/33) calculated" + "; lpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4mpu()
            
                message2print = "{(Step M/33) calculated" + "; mpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4npu()
            
                message2print = "{(Step N/33) calculated" + "; npu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4opu()
            
                message2print = "{(Step O/33) calculated" + "; opu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4ppu()
            
                message2print = "{(Step P/33) calculated" + "; ppu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4qpu()
            
                message2print = "{(Step Q/33) calculated" + "; qpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4rpu()
            
                message2print = "{(Step R/33) calculated" + "; rpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4spu()
            
                message2print = "{(Step S/33) calculated" + "; spu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4tpu()
            
                message2print = "{(Step T/33) calculated" + "; tpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4upu()
            
                message2print = "{(Step U/33) calculated" + "; upu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4vpu()
            
                message2print = "{(Step V/33) calculated" + "; vpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4wpu()
            
                message2print = "{(Step W/33) calculated" + "; wpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4xpu()
            
                message2print = "{(Step X/33) calculated" + "; xpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4ypu()
            
                message2print = "{(Step Y/33) calculated" + "; ypu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response4release2program   = release2program4zpu()
            
                message2print = "{(Step Z/33) calculated" + "; zpu-calculated-by-release2program4xi to: " + str(response4release2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-release2program4xi: " + str(response4release2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of release2program4xi - RETURNING PROGRAM4XI: ", program4xi)
            
    message2print = "{(Step 33/33) returning" + "; program4xi-returning-by-release2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return program4xi
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2program4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO RETAIN PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4retain2program = retain2program4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - RETAIN XI ', time4xi())
#       keys2response = response4retain2program.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4retain2program[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO RETAIN PROGRAM OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2program4xi(task4retain2program=None):

    '''
    retains program of xi
    '''
    global program4xi
    global platform2xi
    global device2xi
    global context2xi 
                                                                                            
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4retain2program = None
    keys2task4retain = task4retain2program.keys()     
    class2print = "retain2program4xi" 
    method2print = "retain2program4xi"

    message2print = "{(Step 1A/70) started" + "; retain2program4xi-started: " + str(retain2program4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4retain2program-to-retain2program4xi: " + str(task4retain2program) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4retain2program is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if response4retain2program is None:                                                                                       
                response4retain2program = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            response4retain2program = create2programwithsource4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4retain2program-try-by-retain2program4xi: " + str(task4retain2program)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4retain2program = retain2program4apu()                                                                        
            response4retain2program = retain2program4bpu()   
            response4retain2program = retain2program4cpu()   
            response4retain2program = retain2program4dpu()   
            response4retain2program = retain2program4epu()   
            response4retain2program = retain2program4fpu()   
            response4retain2program = retain2program4gpu()   
            response4retain2program = retain2program4hpu()   
            response4retain2program = retain2program4ipu()   
            response4retain2program = retain2program4jpu()   
            response4retain2program = retain2program4kpu()   
            response4retain2program = retain2program4lpu()   
            response4retain2program = retain2program4mpu()   
            response4retain2program = retain2program4npu()   
            response4retain2program = retain2program4opu()   
            response4retain2program = retain2program4ppu()   
            response4retain2program = retain2program4qpu()   
            response4retain2program = retain2program4rpu()   
            response4retain2program = retain2program4spu()   
            response4retain2program = retain2program4tpu()   
            response4retain2program = retain2program4upu()   
            response4retain2program = retain2program4vpu()   
            response4retain2program = retain2program4xpu()   
            response4retain2program = retain2program4wpu()   
            response4retain2program = retain2program4ypu()   
            response4retain2program = retain2program4zpu()   
            
            message2print = "{(Step 3A/33) set" + "; response4retain2program-set-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; response4retain2program-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        if 'APU' in keys2task4retain:   
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response4retain2program  = retain2program4apu()
            
                message2print = "{(Step A/33) calculated" + "; apu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2task4retain:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4bpu()
            
                message2print = "{(Step B/33) calculated" + "; bpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4cpu()
            
                message2print = "{(Step C/33) calculated" + "; cpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4dpu()
            
                message2print = "{(Step D/33) calculated" + "; dpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4epu()
            
                message2print = "{(Step E/33) calculated" + "; epu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4fpu()
            
                message2print = "{(Step F/33) calculated" + "; fpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4gpu()
            
                message2print = "{(Step G/33) calculated" + "; gpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4hpu()
            
                message2print = "{(Step H/33) calculated" + "; hpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4ipu()
            
                message2print = "{(Step I/33) calculated" + "; ipu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4jpu()
            
                message2print = "{(Step J/33) calculated" + "; jpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4kpu()
            
                message2print = "{(Step K/33) calculated" + "; kpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4lpu()
            
                message2print = "{(Step L/33) calculated" + "; lpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4mpu()
            
                message2print = "{(Step M/33) calculated" + "; mpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4npu()
            
                message2print = "{(Step N/33) calculated" + "; npu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4opu()
            
                message2print = "{(Step O/33) calculated" + "; opu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4ppu()
            
                message2print = "{(Step P/33) calculated" + "; ppu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4qpu()
            
                message2print = "{(Step Q/33) calculated" + "; qpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4rpu()
            
                message2print = "{(Step R/33) calculated" + "; rpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4spu()
            
                message2print = "{(Step S/33) calculated" + "; spu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4tpu()
            
                message2print = "{(Step T/33) calculated" + "; tpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4upu()
            
                message2print = "{(Step U/33) calculated" + "; upu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4vpu()
            
                message2print = "{(Step V/33) calculated" + "; vpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4wpu()
            
                message2print = "{(Step W/33) calculated" + "; wpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4xpu()
            
                message2print = "{(Step X/33) calculated" + "; xpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4ypu()
            
                message2print = "{(Step Y/33) calculated" + "; ypu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response4retain2program   = retain2program4zpu()
            
                message2print = "{(Step Z/33) calculated" + "; zpu-calculated-by-retain2program4xi to: " + str(response4retain2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-retain2program4xi: " + str(response4retain2program) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of retain2program4xi - RETURNING PROGRAM4XI: ", program4xi)
            
    message2print = "{(Step 33/33) returning" + "; program4xi-returning-by-retain2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return program4xi
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "link2program4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO LINK PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4link2program = link2program4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - LINK XI ', time4xi())
#       keys2response = response4link2program.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4link2program[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO LINK PROGRAM OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def link2program4xi(task4link2program=None):

    '''
    links program of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response2link4xi = {} 
        
    class2print = "link2program4xi"  
    method2print = "link2program4xi"

    message2print = "{(Step 1A/70) started" + "; link2program4xi-started: " + str(link2program4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4link2program-to-link2program4xi: " + str(task4link2program) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'BPU': 'Yes'}

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4link2program is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithsource4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4link2program-try-by-link2program4xi: " + str(task4link2program)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'BPU': 'Yes'}
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response2link4xi['APU'] = link2program4apu()                                                                        
            response2link4xi['BPU'] = link2program4bpu()   
            response2link4xi['CPU'] = link2program4cpu()   
            response2link4xi['DPU'] = link2program4dpu()   
            response2link4xi['EPU'] = link2program4epu()   
            response2link4xi['FPU'] = link2program4fpu()   
            response2link4xi['GPU'] = link2program4gpu()   
            response2link4xi['HPU'] = link2program4hpu()   
            response2link4xi['IPU'] = link2program4ipu()   
            response2link4xi['JPU'] = link2program4jpu()   
            response2link4xi['KPU'] = link2program4kpu()   
            response2link4xi['LPU'] = link2program4lpu()   
            response2link4xi['MPU'] = link2program4mpu()   
            response2link4xi['NPU'] = link2program4npu()   
            response2link4xi['OPU'] = link2program4opu()   
            response2link4xi['PPU'] = link2program4ppu()   
            response2link4xi['QPU'] = link2program4qpu()   
            response2link4xi['RPU'] = link2program4rpu()   
            response2link4xi['SPU'] = link2program4spu()   
            response2link4xi['TPU'] = link2program4tpu()   
            response2link4xi['UPU'] = link2program4upu()   
            response2link4xi['VPU'] = link2program4vpu()   
            response2link4xi['XPU'] = link2program4xpu()   
            response2link4xi['WPU'] = link2program4wpu()   
            response2link4xi['YPU'] = link2program4ypu()   
            response2link4xi['ZPU'] = link2program4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; response2link4xi-got-by-link2program4xi: " + str(response2link4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['APU'] = link2program4apu()
            
            message2print = "{(Step A/33) got" + "; apu-got-by-link2program4xi: " + str(program4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['BPU'] = link2program4bpu()
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-link2program4xi: " + str(program4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['CPU'] = link2program4cpu()
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-link2program4xi: " + str(program4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['DPU'] = link2program4dpu()
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-link2program4xi: " + str(program4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['EPU'] = link2program4epu()
            
            message2print = "{(Step E/33) got" + "; epu-got-by-link2program4xi: " + str(program4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['FPU'] = link2program4fpu()
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-link2program4xi: " + str(program4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['GPU'] = link2program4gpu()
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-link2program4xi: " + str(program4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['HPU'] = link2program4hpu()
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-link2program4xi: " + str(program4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['IPU'] = link2program4ipu()
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-link2program4xi: " + str(program4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['JPU'] = link2program4jpu()
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-link2program4xi: " + str(program4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['KPU'] = link2program4kpu()
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-link2program4xi: " + str(program4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['LPU'] = link2program4lpu()
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-link2program4xi: " + str(program4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['MPU'] = link2program4mpu()
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-link2program4xi: " + str(program4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['NPU'] = link2program4npu()
            
            message2print = "{(Step N/33) got" + "; npu-got-by-link2program4xi: " + str(program4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['OPU'] = link2program4opu()
            
            message2print = "{(Step O/33) got" + "; opu-got-by-link2program4xi: " + str(program4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['PPU'] = link2program4ppu()
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-link2program4xi: " + str(program4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['QPU'] = link2program4qpu()
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-link2program4xi: " + str(program4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['RPU'] = link2program4rpu()
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-link2program4xi: " + str(program4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['SPU'] = link2program4spu()
            
            message2print = "{(Step S/33) got" + "; spu-got-by-link2program4xi: " + str(program4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['TPU'] = link2program4tpu()
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-link2program4xi: " + str(program4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['UPU'] = link2program4upu()
            
            message2print = "{(Step U/33) got" + "; upu-got-by-link2program4xi: " + str(program4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['VPU'] = link2program4vpu()
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-link2program4xi: " + str(program4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['WPU'] = link2program4wpu()
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-link2program4xi: " + str(program4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['XPU'] = link2program4xpu()
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-link2program4xi: " + str(program4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['YPU'] = link2program4ypu()
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-link2program4xi: " + str(program4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response2link4xi['ZPU'] = link2program4zpu()
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-link2program4xi: " + str(program4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-link2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of link2program4xi - RETURNING response2link4xi: ", response2link4xi)
            
    message2print = "{(Step 33/33) returning" + "; response2link4xi-returning-by-link2program4xi: " + str(response2link4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response2link4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2programinfo4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO GET PROGRAM INFO PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4get2programinfo = get2programinfo4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - GET PROGRAM INFO XI ', time4xi())
#       keys2response = response4get2programinfo.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4get2programinfo[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO GET PROGRAM INFO PROGRAM OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def get2programinfo4xi(task4get2programinfo=None):

    '''
    gets program info of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    response4programinfo = {} 
    debug = False
        
    class2print = "get2programinfo4xi" 
    method2print = "get2programinfo4xi"

    message2print = "{(Step 1A/70) started" + "; get2programinfo4xi-started: " + str(get2programinfo4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4get2programinfo-to-get2programinfo4xi: " + str(task4get2programinfo) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4get2programinfo is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithsource4xi() 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4get2programinfo-try-by-get2programinfo4xi: " + str(task4get2programinfo)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4programinfo['APU'] = get2programinfo4apu()                                                                        
            response4programinfo['BPU'] = get2programinfo4bpu()   
            response4programinfo['CPU'] = get2programinfo4cpu()   
            response4programinfo['DPU'] = get2programinfo4dpu()   
            response4programinfo['EPU'] = get2programinfo4epu()   
            response4programinfo['FPU'] = get2programinfo4fpu()   
            response4programinfo['GPU'] = get2programinfo4gpu()   
            response4programinfo['HPU'] = get2programinfo4hpu()   
            response4programinfo['IPU'] = get2programinfo4ipu()   
            response4programinfo['JPU'] = get2programinfo4jpu()   
            response4programinfo['KPU'] = get2programinfo4kpu()   
            response4programinfo['LPU'] = get2programinfo4lpu()   
            response4programinfo['MPU'] = get2programinfo4mpu()   
            response4programinfo['NPU'] = get2programinfo4npu()   
            response4programinfo['OPU'] = get2programinfo4opu()   
            response4programinfo['PPU'] = get2programinfo4ppu()   
            response4programinfo['QPU'] = get2programinfo4qpu()   
            response4programinfo['RPU'] = get2programinfo4rpu()   
            response4programinfo['SPU'] = get2programinfo4spu()   
            response4programinfo['TPU'] = get2programinfo4tpu()   
            response4programinfo['UPU'] = get2programinfo4upu()   
            response4programinfo['VPU'] = get2programinfo4vpu()   
            response4programinfo['XPU'] = get2programinfo4xpu()   
            response4programinfo['WPU'] = get2programinfo4wpu()   
            response4programinfo['YPU'] = get2programinfo4ypu()   
            response4programinfo['ZPU'] = get2programinfo4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-get2programinfo4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['APU'] = get2programinfo4apu(task4get2programinfo['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-get2programinfo4xi: " + str(response4programinfo['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['BPU'] = get2programinfo4bpu(task4get2programinfo['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-get2programinfo4xi: " + str(response4programinfo['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['CPU'] = get2programinfo4cpu(task4get2programinfo['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-get2programinfo4xi: " + str(response4programinfo['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['DPU'] = get2programinfo4dpu(task4get2programinfo['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-get2programinfo4xi: " + str(response4programinfo['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['EPU'] = get2programinfo4epu(task4get2programinfo['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-get2programinfo4xi: " + str(response4programinfo['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['FPU'] = get2programinfo4fpu(task4get2programinfo['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-get2programinfo4xi: " + str(response4programinfo['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['GPU'] = get2programinfo4gpu(task4get2programinfo['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-get2programinfo4xi: " + str(response4programinfo['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['HPU'] = get2programinfo4hpu(task4get2programinfo['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-get2programinfo4xi: " + str(response4programinfo['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['IPU'] = get2programinfo4ipu(task4get2programinfo['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-get2programinfo4xi: " + str(response4programinfo['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['JPU'] = get2programinfo4jpu(task4get2programinfo['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-get2programinfo4xi: " + str(response4programinfo['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['KPU'] = get2programinfo4kpu(task4get2programinfo['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-get2programinfo4xi: " + str(response4programinfo['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['LPU'] = get2programinfo4lpu(task4get2programinfo['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-get2programinfo4xi: " + str(response4programinfo['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['MPU'] = get2programinfo4mpu(task4get2programinfo['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-get2programinfo4xi: " + str(response4programinfo['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['NPU'] = get2programinfo4npu(task4get2programinfo['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-get2programinfo4xi: " + str(response4programinfo['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['OPU'] = get2programinfo4opu(task4get2programinfo['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-get2programinfo4xi: " + str(response4programinfo['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['PPU'] = get2programinfo4ppu(task4get2programinfo['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-get2programinfo4xi: " + str(response4programinfo['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['QPU'] = get2programinfo4qpu(task4get2programinfo['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-get2programinfo4xi: " + str(response4programinfo['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['RPU'] = get2programinfo4rpu(task4get2programinfo['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-get2programinfo4xi: " + str(response4programinfo['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['SPU'] = get2programinfo4spu(task4get2programinfo['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-get2programinfo4xi: " + str(response4programinfo['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['TPU'] = get2programinfo4tpu(task4get2programinfo['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-get2programinfo4xi: " + str(response4programinfo['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['UPU'] = get2programinfo4upu(task4get2programinfo['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-get2programinfo4xi: " + str(response4programinfo['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['VPU'] = get2programinfo4vpu(task4get2programinfo['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-get2programinfo4xi: " + str(response4programinfo['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['WPU'] = get2programinfo4wpu(task4get2programinfo['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-get2programinfo4xi: " + str(response4programinfo['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['XPU'] = get2programinfo4xpu(task4get2programinfo['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-get2programinfo4xi: " + str(response4programinfo['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['YPU'] = get2programinfo4ypu(task4get2programinfo['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-get2programinfo4xi: " + str(response4programinfo['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4programinfo['ZPU'] = get2programinfo4zpu(task4get2programinfo['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-get2programinfo4xi: " + str(response4programinfo['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-get2programinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of get2programinfo4xi - RETURNING response4programinfo: ", response4programinfo)
            
    message2print = "{(Step 33/33) returning" + "; response4programinfo-returning-by-get2programinfo4xi: " + str(response4programinfo) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4programinfo
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2programbuildinfo4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO GET PROGRAM BUILD INFO PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4get2programbuildinfo = get2programbuildinfo4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - GET PROGRAM BUILD INFO XI ', time4xi())
#       keys2response = response4get2programbuildinfo.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4get2programbuildinfo[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO GET PROGRAM BUILD INFO PROGRAM OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def get2programbuildinfo4xi(task4get2programbuildinfo=None):

    '''
    geta program build info of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    response4programbuildinfo = {} 
    debug = False
        
    class2print = "get2programbuildinfo4xi" 
    method2print = "get2programbuildinfo4xi"

    message2print = "{(Step 1A/70) started" + "; get2programbuildinfo4xi-started: " + str(get2programbuildinfo4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4get2programbuildinfo-to-get2programbuildinfo4xi: " + str(task4get2programbuildinfo) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4get2programbuildinfo is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithsource4xi() 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4get2programbuildinfo-try-by-get2programbuildinfo4xi: " + str(task4get2programbuildinfo)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4programbuildinfo['APU'] = get2programbuildinfo4apu()                                                                        
            response4programbuildinfo['BPU'] = get2programbuildinfo4bpu()   
            response4programbuildinfo['CPU'] = get2programbuildinfo4cpu()   
            response4programbuildinfo['DPU'] = get2programbuildinfo4dpu()   
            response4programbuildinfo['EPU'] = get2programbuildinfo4epu()   
            response4programbuildinfo['FPU'] = get2programbuildinfo4fpu()   
            response4programbuildinfo['GPU'] = get2programbuildinfo4gpu()   
            response4programbuildinfo['HPU'] = get2programbuildinfo4hpu()   
            response4programbuildinfo['IPU'] = get2programbuildinfo4ipu()   
            response4programbuildinfo['JPU'] = get2programbuildinfo4jpu()   
            response4programbuildinfo['KPU'] = get2programbuildinfo4kpu()   
            response4programbuildinfo['LPU'] = get2programbuildinfo4lpu()   
            response4programbuildinfo['MPU'] = get2programbuildinfo4mpu()   
            response4programbuildinfo['NPU'] = get2programbuildinfo4npu()   
            response4programbuildinfo['OPU'] = get2programbuildinfo4opu()   
            response4programbuildinfo['PPU'] = get2programbuildinfo4ppu()   
            response4programbuildinfo['QPU'] = get2programbuildinfo4qpu()   
            response4programbuildinfo['RPU'] = get2programbuildinfo4rpu()   
            response4programbuildinfo['SPU'] = get2programbuildinfo4spu()   
            response4programbuildinfo['TPU'] = get2programbuildinfo4tpu()   
            response4programbuildinfo['UPU'] = get2programbuildinfo4upu()   
            response4programbuildinfo['VPU'] = get2programbuildinfo4vpu()   
            response4programbuildinfo['XPU'] = get2programbuildinfo4xpu()   
            response4programbuildinfo['WPU'] = get2programbuildinfo4wpu()   
            response4programbuildinfo['YPU'] = get2programbuildinfo4ypu()   
            response4programbuildinfo['ZPU'] = get2programbuildinfo4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-get2programbuildinfo4xi to: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['APU'] = get2programbuildinfo4apu(task4get2programbuildinfo['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['BPU'] = get2programbuildinfo4bpu(task4get2programbuildinfo['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['CPU'] = get2programbuildinfo4cpu(task4get2programbuildinfo['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['DPU'] = get2programbuildinfo4dpu(task4get2programbuildinfo['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['EPU'] = get2programbuildinfo4epu(task4get2programbuildinfo['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['FPU'] = get2programbuildinfo4fpu(task4get2programbuildinfo['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['GPU'] = get2programbuildinfo4gpu(task4get2programbuildinfo['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['HPU'] = get2programbuildinfo4hpu(task4get2programbuildinfo['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['IPU'] = get2programbuildinfo4ipu(task4get2programbuildinfo['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['JPU'] = get2programbuildinfo4jpu(task4get2programbuildinfo['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['KPU'] = get2programbuildinfo4kpu(task4get2programbuildinfo['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['LPU'] = get2programbuildinfo4lpu(task4get2programbuildinfo['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['MPU'] = get2programbuildinfo4mpu(task4get2programbuildinfo['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['NPU'] = get2programbuildinfo4npu(task4get2programbuildinfo['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['OPU'] = get2programbuildinfo4opu(task4get2programbuildinfo['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['PPU'] = get2programbuildinfo4ppu(task4get2programbuildinfo['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['QPU'] = get2programbuildinfo4qpu(task4get2programbuildinfo['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['RPU'] = get2programbuildinfo4rpu(task4get2programbuildinfo['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['SPU'] = get2programbuildinfo4spu(task4get2programbuildinfo['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['TPU'] = get2programbuildinfo4tpu(task4get2programbuildinfo['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['UPU'] = get2programbuildinfo4upu(task4get2programbuildinfo['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['VPU'] = get2programbuildinfo4vpu(task4get2programbuildinfo['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['WPU'] = get2programbuildinfo4wpu(task4get2programbuildinfo['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['XPU'] = get2programbuildinfo4xpu(task4get2programbuildinfo['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['YPU'] = get2programbuildinfo4ypu(task4get2programbuildinfo['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4programbuildinfo['ZPU'] = get2programbuildinfo4zpu(task4get2programbuildinfo['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-get2programbuildinfo4xi: " + str(response4programbuildinfo['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-get2programbuildinfo4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of get2programbuildinfo4xi - RETURNING response4programbuildinfo: ", response4programbuildinfo)
            
    message2print = "{(Step 33/33) returning" + "; response4programbuildinfo-returning-by-get2programbuildinfo4xi: " + str(response4programbuildinfo) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4programbuildinfo
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2programwithbinary4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO DELETE PROGRAM WITH BINARY PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4delete2pwb = delete2programwithbinary4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - DELETE PROGRAM WITH BINARY PROGRAM XI ', time4xi())
#       keys2response = response4delete2pwb.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4delete2pwb[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO DELETE PROGRAM WITH BINARY PROGRAM OF XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def delete2programwithbinary4xi(task4delete2pwb=None):

    '''
    deletes binary inside program of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4delete2pwb = {}    
    class2print = "delete2programwithbinary4xi" 
    method2print = "delete2programwithbinary4xi"

    message2print = "{(Step 1A/70) started" + "; delete2programwithbinary4xi-started: " + str(delete2programwithbinary4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4delete2pwb-to-delete2programwithbinary4xi: " + str(task4delete2pwb) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4delete2pwb is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithbinary4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithbinary4xi() 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4delete2pwb-try-by-delete2programwithbinary4xi: " + str(task4delete2pwb)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response4delete2pwb['APU'] = delete2programwithbinary4apu()                                                                        
            response4delete2pwb['BPU'] = delete2programwithbinary4bpu()   
            response4delete2pwb['CPU'] = delete2programwithbinary4cpu()   
            response4delete2pwb['DPU'] = delete2programwithbinary4dpu()   
            response4delete2pwb['EPU'] = delete2programwithbinary4epu()   
            response4delete2pwb['FPU'] = delete2programwithbinary4fpu()   
            response4delete2pwb['GPU'] = delete2programwithbinary4gpu()   
            response4delete2pwb['HPU'] = delete2programwithbinary4hpu()   
            response4delete2pwb['IPU'] = delete2programwithbinary4ipu()   
            response4delete2pwb['JPU'] = delete2programwithbinary4jpu()   
            response4delete2pwb['KPU'] = delete2programwithbinary4kpu()   
            response4delete2pwb['LPU'] = delete2programwithbinary4lpu()   
            response4delete2pwb['MPU'] = delete2programwithbinary4mpu()   
            response4delete2pwb['NPU'] = delete2programwithbinary4npu()   
            response4delete2pwb['OPU'] = delete2programwithbinary4opu()   
            response4delete2pwb['PPU'] = delete2programwithbinary4ppu()   
            response4delete2pwb['QPU'] = delete2programwithbinary4qpu()   
            response4delete2pwb['RPU'] = delete2programwithbinary4rpu()   
            response4delete2pwb['SPU'] = delete2programwithbinary4spu()   
            response4delete2pwb['TPU'] = delete2programwithbinary4tpu()   
            response4delete2pwb['UPU'] = delete2programwithbinary4upu()   
            response4delete2pwb['VPU'] = delete2programwithbinary4vpu()   
            response4delete2pwb['XPU'] = delete2programwithbinary4xpu()   
            response4delete2pwb['WPU'] = delete2programwithbinary4wpu()   
            response4delete2pwb['YPU'] = delete2programwithbinary4ypu()   
            response4delete2pwb['ZPU'] = delete2programwithbinary4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-delete2programwithbinary4xi: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['APU'] = delete2programwithbinary4apu(task4delete2pwb['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['BPU'] = delete2programwithbinary4bpu(task4delete2pwb['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['CPU'] = delete2programwithbinary4cpu(task4delete2pwb['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['DPU'] = delete2programwithbinary4dpu(task4delete2pwb['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['EPU'] = delete2programwithbinary4epu(task4delete2pwb['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['FPU'] = delete2programwithbinary4fpu(task4delete2pwb['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['GPU'] = delete2programwithbinary4gpu(task4delete2pwb['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['HPU'] = delete2programwithbinary4hpu(task4delete2pwb['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['IPU'] = delete2programwithbinary4ipu(task4delete2pwb['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['JPU'] = delete2programwithbinary4jpu(task4delete2pwb['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['KPU'] = delete2programwithbinary4kpu(task4delete2pwb['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['LPU'] = delete2programwithbinary4lpu(task4delete2pwb['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['MPU'] = delete2programwithbinary4mpu(task4delete2pwb['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['NPU'] = delete2programwithbinary4npu(task4delete2pwb['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['OPU'] = delete2programwithbinary4opu(task4delete2pwb['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['PPU'] = delete2programwithbinary4ppu(task4delete2pwb['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['QPU'] = delete2programwithbinary4qpu(task4delete2pwb['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['RPU'] = delete2programwithbinary4rpu(task4delete2pwb['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['SPU'] = delete2programwithbinary4spu(task4delete2pwb['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['TPU'] = delete2programwithbinary4tpu(task4delete2pwb['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['UPU'] = delete2programwithbinary4upu(task4delete2pwb['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['VPU'] = delete2programwithbinary4vpu(task4delete2pwb['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['WPU'] = delete2programwithbinary4wpu(task4delete2pwb['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['XPU'] = delete2programwithbinary4xpu(task4delete2pwb['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['YPU'] = delete2programwithbinary4ypu(task4delete2pwb['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['ZPU'] = delete2programwithbinary4zpu(task4delete2pwb['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-delete2programwithbinary4xi: " + str(response4delete2pwb['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-delete2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of delete2programwithbinary4xi - RETURNING response4delete2pwb: ", response4delete2pwb)
            
    message2print = "{(Step 33/33) returning" + "; response4delete2pwb-returning-by-delete2programwithbinary4xi: " + str(response4delete2pwb) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4delete2pwb
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2programwithsource4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO DELETE PROGRAM WITH SOURCE PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4delete2pwb = delete2programwithsource4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - DELETE PROGRAM WITH SOURCE PROGRAM XI ', time4xi())
#       keys2response = response4delete2pwb.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4delete2pwb[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO DELETE PROGRAM WITH SOURCE PROGRAM OF XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def delete2programwithsource4xi(task4delete2pwb=None):

    '''
    deletes source inside program of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4delete2pwb = {}    
    class2print = "delete2programwithsource4xi" 
    method2print = "delete2programwithsource4xi"

    message2print = "{(Step 1A/70) started" + "; delete2programwithsource4xi-started: " + str(delete2programwithsource4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function delete2programwithsource4xi at 0x00000000054B0E48>
  
             
    message2print = "{(Step 1B/70) passed" + "; task4delete2pwb-to-delete2programwithsource4xi: " + str(task4delete2pwb) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'APU': {'CODE4SOURCE': {'e://scope4xi//041721//zap//lib//a//apu2dummy4xi5test.py': 'Yes'}}}; time: 01:08:06 11/29/11 Pacific Standard Time}


    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4delete2pwb is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithsource4xi() 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4delete2pwb-try-by-delete2programwithsource4xi: " + str(task4delete2pwb)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'APU': {'CODE4SOURCE': {'e://scope4xi//041721//zap//lib//a//apu2dummy4xi5test.py': 'Yes'}}}; time: 01:08:06 11/29/11 Pacific Standard Time}
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response4delete2pwb['APU'] = delete2programwithsource4apu()                                                                        
            response4delete2pwb['BPU'] = delete2programwithsource4bpu()   
            response4delete2pwb['CPU'] = delete2programwithsource4cpu()   
            response4delete2pwb['DPU'] = delete2programwithsource4dpu()   
            response4delete2pwb['EPU'] = delete2programwithsource4epu()   
            response4delete2pwb['FPU'] = delete2programwithsource4fpu()   
            response4delete2pwb['GPU'] = delete2programwithsource4gpu()   
            response4delete2pwb['HPU'] = delete2programwithsource4hpu()   
            response4delete2pwb['IPU'] = delete2programwithsource4ipu()   
            response4delete2pwb['JPU'] = delete2programwithsource4jpu()   
            response4delete2pwb['KPU'] = delete2programwithsource4kpu()   
            response4delete2pwb['LPU'] = delete2programwithsource4lpu()   
            response4delete2pwb['MPU'] = delete2programwithsource4mpu()   
            response4delete2pwb['NPU'] = delete2programwithsource4npu()   
            response4delete2pwb['OPU'] = delete2programwithsource4opu()   
            response4delete2pwb['PPU'] = delete2programwithsource4ppu()   
            response4delete2pwb['QPU'] = delete2programwithsource4qpu()   
            response4delete2pwb['RPU'] = delete2programwithsource4rpu()   
            response4delete2pwb['SPU'] = delete2programwithsource4spu()   
            response4delete2pwb['TPU'] = delete2programwithsource4tpu()   
            response4delete2pwb['UPU'] = delete2programwithsource4upu()   
            response4delete2pwb['VPU'] = delete2programwithsource4vpu()   
            response4delete2pwb['XPU'] = delete2programwithsource4xpu()   
            response4delete2pwb['WPU'] = delete2programwithsource4wpu()   
            response4delete2pwb['YPU'] = delete2programwithsource4ypu()   
            response4delete2pwb['ZPU'] = delete2programwithsource4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-delete2programwithsource4xi: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['APU'] = delete2programwithsource4apu(task4delete2pwb['APU'])
            
            # delete2programwithsource4apu-started: <function delete2programwithsource4apu at 0x000000000449DD48>;
            message2print = "{(Step A/33) got" + "; apu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['BPU'] = delete2programwithsource4bpu(task4delete2pwb['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['CPU'] = delete2programwithsource4cpu(task4delete2pwb['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['DPU'] = delete2programwithsource4dpu(task4delete2pwb['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['EPU'] = delete2programwithsource4epu(task4delete2pwb['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['FPU'] = delete2programwithsource4fpu(task4delete2pwb['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['GPU'] = delete2programwithsource4gpu(task4delete2pwb['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['HPU'] = delete2programwithsource4hpu(task4delete2pwb['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['IPU'] = delete2programwithsource4ipu(task4delete2pwb['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['JPU'] = delete2programwithsource4jpu(task4delete2pwb['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['KPU'] = delete2programwithsource4kpu(task4delete2pwb['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['LPU'] = delete2programwithsource4lpu(task4delete2pwb['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['MPU'] = delete2programwithsource4mpu(task4delete2pwb['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['NPU'] = delete2programwithsource4npu(task4delete2pwb['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['OPU'] = delete2programwithsource4opu(task4delete2pwb['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['PPU'] = delete2programwithsource4ppu(task4delete2pwb['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['QPU'] = delete2programwithsource4qpu(task4delete2pwb['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['RPU'] = delete2programwithsource4rpu(task4delete2pwb['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['SPU'] = delete2programwithsource4spu(task4delete2pwb['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['TPU'] = delete2programwithsource4tpu(task4delete2pwb['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['UPU'] = delete2programwithsource4upu(task4delete2pwb['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['VPU'] = delete2programwithsource4vpu(task4delete2pwb['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['WPU'] = delete2programwithsource4wpu(task4delete2pwb['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['XPU'] = delete2programwithsource4xpu(task4delete2pwb['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['YPU'] = delete2programwithsource4ypu(task4delete2pwb['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4delete2pwb['ZPU'] = delete2programwithsource4zpu(task4delete2pwb['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-delete2programwithsource4xi: " + str(response4delete2pwb['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-delete2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of delete2programwithsource4xi - RETURNING response4delete2pwb: ", response4delete2pwb)
            
    message2print = "{(Step 33/33) returning" + "; response4delete2pwb-returning-by-delete2programwithsource4xi: " + str(response4delete2pwb) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4delete2pwb
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "compile2program4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO COMPILE PROGRAM WITH SOURCE PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4compile = compile2program4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - COMPILE PROGRAM WITH SOURCE PROGRAM XI ', time4xi())
#       keys2response = response4compile.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4compile[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO COMPILE PROGRAM WITH SOURCE PROGRAM OF XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def compile2program4xi(task4compile=None):

    '''
    compiles inside program of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4compile = {}    
    class2print = "compile2program4xi" 
    method2print = "compile2program4xi"

    message2print = "{(Step 1A/70) started" + "; compile2program4xi-started: " + str(compile2program4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4compile-to-compile2program4xi: " + str(task4compile) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4compile is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithsource4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4compile-try-by-compile2program4xi: " + str(task4compile)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response4compile['APU'] = compile2program4apu()                                                                        
            response4compile['BPU'] = compile2program4bpu()   
            response4compile['CPU'] = compile2program4cpu()   
            response4compile['DPU'] = compile2program4dpu()   
            response4compile['EPU'] = compile2program4epu()   
            response4compile['FPU'] = compile2program4fpu()   
            response4compile['GPU'] = compile2program4gpu()   
            response4compile['HPU'] = compile2program4hpu()   
            response4compile['IPU'] = compile2program4ipu()   
            response4compile['JPU'] = compile2program4jpu()   
            response4compile['KPU'] = compile2program4kpu()   
            response4compile['LPU'] = compile2program4lpu()   
            response4compile['MPU'] = compile2program4mpu()   
            response4compile['NPU'] = compile2program4npu()   
            response4compile['OPU'] = compile2program4opu()   
            response4compile['PPU'] = compile2program4ppu()   
            response4compile['QPU'] = compile2program4qpu()   
            response4compile['RPU'] = compile2program4rpu()   
            response4compile['SPU'] = compile2program4spu()   
            response4compile['TPU'] = compile2program4tpu()   
            response4compile['UPU'] = compile2program4upu()   
            response4compile['VPU'] = compile2program4vpu()   
            response4compile['XPU'] = compile2program4xpu()   
            response4compile['WPU'] = compile2program4wpu()   
            response4compile['YPU'] = compile2program4ypu()   
            response4compile['ZPU'] = compile2program4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-compile2program4xi: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4compile['APU'] = compile2program4apu()
            
            message2print = "{(Step A/33) got" + "; apu-got-by-compile2program4xi: " + str(response4compile['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4compile['BPU'] = compile2program4bpu()
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-compile2program4xi: " + str(response4compile['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4compile['CPU'] = compile2program4cpu()
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-compile2program4xi: " + str(response4compile['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4compile['DPU'] = compile2program4dpu()
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-compile2program4xi: " + str(response4compile['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4compile['EPU'] = compile2program4epu()
            
            message2print = "{(Step E/33) got" + "; epu-got-by-compile2program4xi: " + str(response4compile['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4compile['FPU'] = compile2program4fpu()
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-compile2program4xi: " + str(response4compile['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4compile['GPU'] = compile2program4gpu()
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-compile2program4xi: " + str(response4compile['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4compile['HPU'] = compile2program4hpu()
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-compile2program4xi: " + str(response4compile['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4compile['IPU'] = compile2program4ipu()
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-compile2program4xi: " + str(response4compile['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4compile['JPU'] = compile2program4jpu()
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-compile2program4xi: " + str(response4compile['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4compile['KPU'] = compile2program4kpu()
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-compile2program4xi: " + str(response4compile['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4compile['LPU'] = compile2program4lpu()
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-compile2program4xi: " + str(response4compile['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4compile['MPU'] = compile2program4mpu()
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-compile2program4xi: " + str(response4compile['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4compile['NPU'] = compile2program4npu()
            
            message2print = "{(Step N/33) got" + "; npu-got-by-compile2program4xi: " + str(response4compile['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4compile['OPU'] = compile2program4opu()
            
            message2print = "{(Step O/33) got" + "; opu-got-by-compile2program4xi: " + str(response4compile['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4compile['PPU'] = compile2program4ppu()
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-compile2program4xi: " + str(response4compile['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4compile['QPU'] = compile2program4qpu()
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-compile2program4xi: " + str(response4compile['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4compile['RPU'] = compile2program4rpu()
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-compile2program4xi: " + str(response4compile['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4compile['SPU'] = compile2program4spu()
            
            message2print = "{(Step S/33) got" + "; spu-got-by-compile2program4xi: " + str(response4compile['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4compile['TPU'] = compile2program4tpu()
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-compile2program4xi: " + str(response4compile['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4compile['UPU'] = compile2program4upu()
            
            message2print = "{(Step U/33) got" + "; upu-got-by-compile2program4xi: " + str(response4compile['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4compile['VPU'] = compile2program4vpu()
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-compile2program4xi: " + str(response4compile['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4compile['WPU'] = compile2program4wpu()
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-compile2program4xi: " + str(response4compile['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4compile['XPU'] = compile2program4xpu()
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-compile2program4xi: " + str(response4compile['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4compile['YPU'] = compile2program4ypu()
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-compile2program4xi: " + str(response4compile['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4compile['ZPU'] = compile2program4zpu()
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-compile2program4xi: " + str(response4compile['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-compile2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of compile2program4xi - RETURNING response4compile: ", response4compile)
            
    message2print = "{(Step 33/33) returning" + "; response4compile-returning-by-compile2program4xi: " + str(response4compile) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4compile
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2program4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO BUILD PROGRAM WITH SOURCE PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4build = build2program4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - BUILD PROGRAM WITH SOURCE PROGRAM XI ', time4xi())
#       keys2response = response4build.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4build[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO BUILD PROGRAM WITH SOURCE PROGRAM OF XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def build2program4xi(task4build=None):

    '''
    builds inside program of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4build = {}    
    class2print = "build2program4xi" 
    method2print = "build2program4xi"

    message2print = "{(Step 1A/70) started" + "; build2program4xi-started: " + str(build2program4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4build-to-build2program4xi: " + str(task4build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4build is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithsource4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4build-try-by-build2program4xi: " + str(task4build)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response4build['APU'] = build2program4apu()                                                                        
            response4build['BPU'] = build2program4bpu()   
            response4build['CPU'] = build2program4cpu()   
            response4build['DPU'] = build2program4dpu()   
            response4build['EPU'] = build2program4epu()   
            response4build['FPU'] = build2program4fpu()   
            response4build['GPU'] = build2program4gpu()   
            response4build['HPU'] = build2program4hpu()   
            response4build['IPU'] = build2program4ipu()   
            response4build['JPU'] = build2program4jpu()   
            response4build['KPU'] = build2program4kpu()   
            response4build['LPU'] = build2program4lpu()   
            response4build['MPU'] = build2program4mpu()   
            response4build['NPU'] = build2program4npu()   
            response4build['OPU'] = build2program4opu()   
            response4build['PPU'] = build2program4ppu()   
            response4build['QPU'] = build2program4qpu()   
            response4build['RPU'] = build2program4rpu()   
            response4build['SPU'] = build2program4spu()   
            response4build['TPU'] = build2program4tpu()   
            response4build['UPU'] = build2program4upu()   
            response4build['VPU'] = build2program4vpu()   
            response4build['XPU'] = build2program4xpu()   
            response4build['WPU'] = build2program4wpu()   
            response4build['YPU'] = build2program4ypu()   
            response4build['ZPU'] = build2program4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-build2program4xi: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        keys2build4task = task4build.keys()
        if 'APU' in keys2build4task:    
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response4build['APU'] = build2program4apu()
            
                message2print = "{(Step A/33) got" + "; apu-got-by-build2program4xi: " + str(response4build['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2build4task: 
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response4build['BPU'] = build2program4bpu()
            
                message2print = "{(Step B/33) got" + "; bpu-got-by-build2program4xi: " + str(response4build['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response4build['CPU'] = build2program4cpu()
            
                message2print = "{(Step C/33) got" + "; cpu-got-by-build2program4xi: " + str(response4build['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response4build['DPU'] = build2program4dpu()
            
                message2print = "{(Step D/33) got" + "; dpu-got-by-build2program4xi: " + str(response4build['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response4build['EPU'] = build2program4epu()
            
                message2print = "{(Step E/33) got" + "; epu-got-by-build2program4xi: " + str(response4build['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response4build['FPU'] = build2program4fpu()
            
                message2print = "{(Step F/33) got" + "; fpu-got-by-build2program4xi: " + str(response4build['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response4build['GPU'] = build2program4gpu()
            
                message2print = "{(Step G/33) got" + "; gpu-got-by-build2program4xi: " + str(response4build['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response4build['HPU'] = build2program4hpu()
            
                message2print = "{(Step H/33) got" + "; hpu-got-by-build2program4xi: " + str(response4build['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response4build['IPU'] = build2program4ipu()
            
                message2print = "{(Step I/33) got" + "; ipu-got-by-build2program4xi: " + str(response4build['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response4build['JPU'] = build2program4jpu()
            
                message2print = "{(Step J/33) got" + "; jpu-got-by-build2program4xi: " + str(response4build['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response4build['KPU'] = build2program4kpu()
            
                message2print = "{(Step K/33) got" + "; kpu-got-by-build2program4xi: " + str(response4build['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response4build['LPU'] = build2program4lpu()
            
                message2print = "{(Step L/33) got" + "; lpu-got-by-build2program4xi: " + str(response4build['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response4build['MPU'] = build2program4mpu()
            
                message2print = "{(Step M/33) got" + "; mpu-got-by-build2program4xi: " + str(response4build['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response4build['NPU'] = build2program4npu()
            
                message2print = "{(Step N/33) got" + "; npu-got-by-build2program4xi: " + str(response4build['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response4build['OPU'] = build2program4opu()
            
                message2print = "{(Step O/33) got" + "; opu-got-by-build2program4xi: " + str(response4build['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response4build['PPU'] = build2program4ppu()
            
                message2print = "{(Step P/33) got" + "; ppu-got-by-build2program4xi: " + str(response4build['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response4build['QPU'] = build2program4qpu()
            
                message2print = "{(Step Q/33) got" + "; qpu-got-by-build2program4xi: " + str(response4build['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response4build['RPU'] = build2program4rpu()
            
                message2print = "{(Step R/33) got" + "; rpu-got-by-build2program4xi: " + str(response4build['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response4build['SPU'] = build2program4spu()
            
                message2print = "{(Step S/33) got" + "; spu-got-by-build2program4xi: " + str(response4build['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if '' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response4build['TPU'] = build2program4tpu()
            
                message2print = "{(Step T/33) got" + "; tpu-got-by-build2program4xi: " + str(response4build['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response4build['UPU'] = build2program4upu()
            
                message2print = "{(Step U/33) got" + "; upu-got-by-build2program4xi: " + str(response4build['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response4build['VPU'] = build2program4vpu()
            
                message2print = "{(Step V/33) got" + "; vpu-got-by-build2program4xi: " + str(response4build['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response4build['WPU'] = build2program4wpu()
            
                message2print = "{(Step W/33) got" + "; wpu-got-by-build2program4xi: " + str(response4build['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response4build['XPU'] = build2program4xpu()
            
                message2print = "{(Step X/33) got" + "; xpu-got-by-build2program4xi: " + str(response4build['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response4build['YPU'] = build2program4ypu()
            
                message2print = "{(Step Y/33) got" + "; ypu-got-by-build2program4xi: " + str(response4build['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2build4task:             
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response4build['ZPU'] = build2program4zpu()
            
                message2print = "{(Step Z/33) got" + "; zpu-got-by-build2program4xi: " + str(response4build['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-build2program4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of build2program4xi - RETURNING response4build: ", response4build)
            
    message2print = "{(Step 33/33) returning" + "; response4build-returning-by-build2program4xi: " + str(response4build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4build
            
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2programwithbinary4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO ADD PROGRAM WITH SOURCE PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4add = add2programwithbinary4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - ADD PROGRAM WITH SOURCE PROGRAM XI ', time4xi())
#       keys2response = response4add.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4add[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO ADD PROGRAM WITH SOURCE PROGRAM OF XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def add2programwithbinary4xi(task4add2pwb=None):

    '''
    adds binary into program of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4add = {}    
    class2print = "add2programwithbinary4xi" 
    method2print = "add2programwithbinary4xi"

    message2print = "{(Step 1A/70) started" + "; add2programwithbinary4xi-started: " + str(add2programwithbinary4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4add2pwb-to-add2programwithbinary4xi: " + str(task4add2pwb) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4add2pwb is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithbinary4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithbinary4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4add2pwb-try-by-add2programwithbinary4xi: " + str(task4add2pwb)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response4add['APU'] = add2programwithbinary4apu()                                                                        
            response4add['BPU'] = add2programwithbinary4bpu()   
            response4add['CPU'] = add2programwithbinary4cpu()   
            response4add['DPU'] = add2programwithbinary4dpu()   
            response4add['EPU'] = add2programwithbinary4epu()   
            response4add['FPU'] = add2programwithbinary4fpu()   
            response4add['GPU'] = add2programwithbinary4gpu()   
            response4add['HPU'] = add2programwithbinary4hpu()   
            response4add['IPU'] = add2programwithbinary4ipu()   
            response4add['JPU'] = add2programwithbinary4jpu()   
            response4add['KPU'] = add2programwithbinary4kpu()   
            response4add['LPU'] = add2programwithbinary4lpu()   
            response4add['MPU'] = add2programwithbinary4mpu()   
            response4add['NPU'] = add2programwithbinary4npu()   
            response4add['OPU'] = add2programwithbinary4opu()   
            response4add['PPU'] = add2programwithbinary4ppu()   
            response4add['QPU'] = add2programwithbinary4qpu()   
            response4add['RPU'] = add2programwithbinary4rpu()   
            response4add['SPU'] = add2programwithbinary4spu()   
            response4add['TPU'] = add2programwithbinary4tpu()   
            response4add['UPU'] = add2programwithbinary4upu()   
            response4add['VPU'] = add2programwithbinary4vpu()   
            response4add['XPU'] = add2programwithbinary4xpu()   
            response4add['WPU'] = add2programwithbinary4wpu()   
            response4add['YPU'] = add2programwithbinary4ypu()   
            response4add['ZPU'] = add2programwithbinary4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-add2programwithbinary4xi: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4add['APU'] = add2programwithbinary4apu(task4add2pwb['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-add2programwithbinary4xi: " + str(response4add['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4add['BPU'] = add2programwithbinary4bpu(task4add2pwb['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-add2programwithbinary4xi: " + str(response4add['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4add['CPU'] = add2programwithbinary4cpu(task4add2pwb['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-add2programwithbinary4xi: " + str(response4add['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4add['DPU'] = add2programwithbinary4dpu(task4add2pwb['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-add2programwithbinary4xi: " + str(response4add['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4add['EPU'] = add2programwithbinary4epu(task4add2pwb['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-add2programwithbinary4xi: " + str(response4add['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4add['FPU'] = add2programwithbinary4fpu(task4add2pwb['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-add2programwithbinary4xi: " + str(response4add['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4add['GPU'] = add2programwithbinary4gpu(task4add2pwb['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-add2programwithbinary4xi: " + str(response4add['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4add['HPU'] = add2programwithbinary4hpu(task4add2pwb['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-add2programwithbinary4xi: " + str(response4add['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4add['IPU'] = add2programwithbinary4ipu(task4add2pwb['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-add2programwithbinary4xi: " + str(response4add['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4add['JPU'] = add2programwithbinary4jpu(task4add2pwb['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-add2programwithbinary4xi: " + str(response4add['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4add['KPU'] = add2programwithbinary4kpu(task4add2pwb['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-add2programwithbinary4xi: " + str(response4add['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4add['LPU'] = add2programwithbinary4lpu(task4add2pwb['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-add2programwithbinary4xi: " + str(response4add['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4add['MPU'] = add2programwithbinary4mpu(task4add2pwb['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-add2programwithbinary4xi: " + str(response4add['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4add['NPU'] = add2programwithbinary4npu(task4add2pwb['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-add2programwithbinary4xi: " + str(response4add['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4add['OPU'] = add2programwithbinary4opu(task4add2pwb['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-add2programwithbinary4xi: " + str(response4add['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4add['PPU'] = add2programwithbinary4ppu(task4add2pwb['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-add2programwithbinary4xi: " + str(response4add['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4add['QPU'] = add2programwithbinary4qpu(task4add2pwb['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-add2programwithbinary4xi: " + str(response4add['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4add['RPU'] = add2programwithbinary4rpu(task4add2pwb['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-add2programwithbinary4xi: " + str(response4add['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4add['SPU'] = add2programwithbinary4spu(task4add2pwb['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-add2programwithbinary4xi: " + str(response4add['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4add['TPU'] = add2programwithbinary4tpu(task4add2pwb['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-add2programwithbinary4xi: " + str(response4add['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4add['UPU'] = add2programwithbinary4upu(task4add2pwb['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-add2programwithbinary4xi: " + str(response4add['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4add['VPU'] = add2programwithbinary4vpu(task4add2pwb['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-add2programwithbinary4xi: " + str(response4add['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4add['WPU'] = add2programwithbinary4wpu(task4add2pwb['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-add2programwithbinary4xi: " + str(response4add['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4add['XPU'] = add2programwithbinary4xpu(task4add2pwb['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-add2programwithbinary4xi: " + str(response4add['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4add['YPU'] = add2programwithbinary4ypu(task4add2pwb['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-add2programwithbinary4xi: " + str(response4add['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4add['ZPU'] = add2programwithbinary4zpu(task4add2pwb['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-add2programwithbinary4xi: " + str(response4add['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-add2programwithbinary4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of add2programwithbinary4xi - RETURNING response4add: ", response4add)
            
    message2print = "{(Step 33/33) returning" + "; response4add-returning-by-add2programwithbinary4xi: " + str(response4add) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4add
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2programwithsource4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF PROGRAM4XI5TEST - TRYING TO ADD PROGRAM WITH BINARY PROGRAM OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4add = add2programwithsource4xi()                                                                 
#       print('(Step 2B/700) OF PROGRAM4XI5TEST - ADD PROGRAM WITH BINARY PROGRAM XI ', time4xi())
#       keys2response = response4add.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4add[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF PROGRAM4XI5TEST *** FAILED TO ADD PROGRAM WITH BINARY PROGRAM OF XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def add2programwithsource4xi(task4add2pws=None):

    '''
    adds source into program of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global program4xi
    global info2program4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4add = {}    
    class2print = "add2programwithsource4xi" 
    method2print = "add2programwithsource4xi"

    message2print = "{(Step 1A/70) started" + "; add2programwithsource4xi-started: " + str(add2programwithsource4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #  
  
             
    message2print = "{(Step 1B/70) passed" + "; task4add2pws-to-add2programwithsource4xi: " + str(task4add2pws) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'APU': 
    #   {'CODE4SOURCE': {'e://scope4xi//041721//zap//lib//a//gpu2dummy4xi5test.py': 
    #     {1: '#<profile4xi profile = "33" />\n', 
    #      2: '#<program4xi program = "apu2dummy4xi5test.py" />\n'}}}}; time: 00:03:35 11/29/11 Pacific Standard Time}


    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4add2pws is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - PROGRAM4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if program4xi is None:                                                                                       
                program4xi = create2programwithsource4xi() 
                code2ack  = code2ack + '1D-'
        except:
            program4xi = create2programwithsource4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4add2pws-try-by-add2programwithsource4xi: " + str(task4add2pws)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4add['APU'] = add2programwithsource4apu()                                                                        
            response4add['BPU'] = add2programwithsource4bpu()   
            response4add['CPU'] = add2programwithsource4cpu()   
            response4add['DPU'] = add2programwithsource4dpu()   
            response4add['EPU'] = add2programwithsource4epu()   
            response4add['FPU'] = add2programwithsource4fpu()   
            response4add['GPU'] = add2programwithsource4gpu()   
            response4add['HPU'] = add2programwithsource4hpu()   
            response4add['IPU'] = add2programwithsource4ipu()   
            response4add['JPU'] = add2programwithsource4jpu()   
            response4add['KPU'] = add2programwithsource4kpu()   
            response4add['LPU'] = add2programwithsource4lpu()   
            response4add['MPU'] = add2programwithsource4mpu()   
            response4add['NPU'] = add2programwithsource4npu()   
            response4add['OPU'] = add2programwithsource4opu()   
            response4add['PPU'] = add2programwithsource4ppu()   
            response4add['QPU'] = add2programwithsource4qpu()   
            response4add['RPU'] = add2programwithsource4rpu()   
            response4add['SPU'] = add2programwithsource4spu()   
            response4add['TPU'] = add2programwithsource4tpu()   
            response4add['UPU'] = add2programwithsource4upu()   
            response4add['VPU'] = add2programwithsource4vpu()   
            response4add['XPU'] = add2programwithsource4xpu()   
            response4add['WPU'] = add2programwithsource4wpu()   
            response4add['YPU'] = add2programwithsource4ypu()   
            response4add['ZPU'] = add2programwithsource4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; program4xi-got-by-add2programwithsource4xi: " + str(program4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; program4xi-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4add['APU'] = add2programwithsource4apu(task4add2pws['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-add2programwithsource4xi: " + str(response4add['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'CODE2ERROR': 0,
            #  'LANGUAGE4SOURCE': 'Python',
            #  'COUNT4SOURCE': 2,
            #  'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//a//apu2sampler4xi5test.py': 1337},
            # ... 
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4add['BPU'] = add2programwithsource4bpu(task4add2pws['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-add2programwithsource4xi: " + str(response4add['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4add['CPU'] = add2programwithsource4cpu(task4add2pws['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-add2programwithsource4xi: " + str(response4add['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4add['DPU'] = add2programwithsource4dpu(task4add2pws['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-add2programwithsource4xi: " + str(response4add['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4add['EPU'] = add2programwithsource4epu(task4add2pws['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-add2programwithsource4xi: " + str(response4add['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4add['FPU'] = add2programwithsource4fpu(task4add2pws['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-add2programwithsource4xi: " + str(response4add['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4add['GPU'] = add2programwithsource4gpu(task4add2pws['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-add2programwithsource4xi: " + str(response4add['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4add['HPU'] = add2programwithsource4hpu(task4add2pws['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-add2programwithsource4xi: " + str(response4add['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4add['IPU'] = add2programwithsource4ipu(task4add2pws['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-add2programwithsource4xi: " + str(response4add['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4add['JPU'] = add2programwithsource4jpu(task4add2pws['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-add2programwithsource4xi: " + str(response4add['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4add['KPU'] = add2programwithsource4kpu(task4add2pws['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-add2programwithsource4xi: " + str(response4add['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4add['LPU'] = add2programwithsource4lpu(task4add2pws['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-add2programwithsource4xi: " + str(response4add['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4add['MPU'] = add2programwithsource4mpu(task4add2pws['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-add2programwithsource4xi: " + str(response4add['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4add['NPU'] = add2programwithsource4npu(task4add2pws['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-add2programwithsource4xi: " + str(response4add['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4add['OPU'] = add2programwithsource4opu(task4add2pws['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-add2programwithsource4xi: " + str(response4add['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4add['PPU'] = add2programwithsource4ppu(task4add2pws['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-add2programwithsource4xi: " + str(response4add['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4add['QPU'] = add2programwithsource4qpu(task4add2pws['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-add2programwithsource4xi: " + str(response4add['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4add['RPU'] = add2programwithsource4rpu(task4add2pws['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-add2programwithsource4xi: " + str(response4add['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4add['SPU'] = add2programwithsource4spu(task4add2pws['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-add2programwithsource4xi: " + str(response4add['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4add['TPU'] = add2programwithsource4tpu(task4add2pws['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-add2programwithsource4xi: " + str(response4add['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4add['UPU'] = add2programwithsource4upu(task4add2pws['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-add2programwithsource4xi: " + str(response4add['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4add['VPU'] = add2programwithsource4vpu(task4add2pws['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-add2programwithsource4xi: " + str(response4add['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4add['WPU'] = add2programwithsource4wpu(task4add2pws['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-add2programwithsource4xi: " + str(response4add['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4add['XPU'] = add2programwithsource4xpu(task4add2pws['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-add2programwithsource4xi: " + str(response4add['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4add['YPU'] = add2programwithsource4ypu(task4add2pws['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-add2programwithsource4xi: " + str(response4add['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4add['ZPU'] = add2programwithsource4zpu(task4add2pws['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-add2programwithsource4xi: " + str(response4add['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-add2programwithsource4xi: " + str(program4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of add2programwithsource4xi - RETURNING response4add: ", response4add)
            
    message2print = "{(Step 33/33) returning" + "; response4add-returning-by-add2programwithsource4xi: " + str(response4add) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'APU': 
    #   {'CODE2ERROR': 0,
    #    'LANGUAGE4SOURCE': 'Python', 
    #    'COUNT4SOURCE': 2, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//a//apu2sampler4xi5test.py': 1337} ...

    return response4add
            
#</function4xi>  


                                               
# =================================================================================================
#<class4xi class = "Program4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for XI program" usage = "OpenCL XI program"
#>

# =================================================================================================
class Program4Xi(object): 
    ''' 
    Program4Xi offers  methods for XI program
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2xi = cpu_corecount4xi()
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2programwithbinary',           # ACK 5.6.1   p132            
            'add2programwithsource',           # ACK 5.6.1   p133  
                                
            'build2program',                   # ACK 5.6.2   p137      

            'compile2program',                 # ACK 5.6.3   p139            
            
            'create2programwithsource',        # ACK 5.6.1   p132 
            'create2programwithbinary',        # ACK 5.6.1   p133 
            'create2programwithbuiltinkernels',# NACK 5.6.1  p135   
                       
            'delete2programwithbinary',        # ACK  
            'delete2programwithsource',        # ACK               

            'get2programinfo',                 # ACK 5.6.7   p150 
            'get2programbuildinfo',            # ACK 5.6.7   p153
            
            'link2program',                    # ACK 5.6.3   p142                          
            'release2program',                 # ACK 5.6.1   p136                                         
            'retain2program',                  # ACK 5.6.1   p136
 
            'set2programwithsource',           # ACK
            'set2programwithbinary',           # ACK            
            'set2programcallback',             # ACK 
                              
            'trace2program',                   # ACK
            'unload2compiler'                  # NACK 5.6.6  p149 
            
            'sense',                           # ACK 
            'reason',                          # ACK 
            'ace')                             # ACK         
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Program4Xi" usage = "
    #   print('(Step 105A/700) OF PROGRAM4XI5TEST - CREATING PROGRAM4XI OBJECT ', time4xi())     
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                        
    #       # ---------------------------------------------------------------------------------------------        
    #       programobject2xi = Program4Xi()
    #       print('(Step 105B/700) OF PROGRAM4XI5TEST - CREATED PROGRAM4XI OBJECT: ', programobject2xi)                                  
    #       # 
    #   except:
    #       print('(Step 105Z/700) OF PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM4XI OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4programcreate2xi = None):
        '''
        _init__ method initializes Program4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Program4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-Program4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; program4xi-of-Program4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-program4xi-of-Program4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2xi-sharing-by-program4xi-of-Program4Xi: " + str(Program4Xi.classvariable2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #            
                                
        message2print = "{(Step 1E/33) passed" + "; task4programcreate2xi-passed-to-init-of-Program4Xi: " + str(task4programcreate2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                         
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        apu2program2xi = create2programwithsource4xi(task4programcreate2xi)
        
                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; program4xi-of-Program4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-program4xi-of-Program4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2xi-shared-by-program4xi-of-Program4Xi: " + str(Program4Xi.classvariable2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #           
       
        message2print = "{(Step 3D/33) returning" + "; init-of-Program4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "build2program-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO BUILD PROGRAM FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4build2program = {} 
    #        for key2pu in keys2pu:
    #            task4build2program [key2pu]  = {}
    #                        
    #        response4build2program = p2xi.build2program(task4build2program)                                  
    #        
    #        keys2response = response4build2program.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4build2program[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO BUILD PROGRAM FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def build2program(self, task4build2program = None):
        '''
        builds program for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "build2program"
                     
        message2print = "{(Step 1A/33) started" + "; build2program-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4build2program-passed-to-set-of-Program4Xi: " + str(task4build2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4build2program-passing-to-build2program4xi-by-build2program-of-Program4Xi: " + str(task4build2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = build2program4xi(task4build2program)

        message2print = "{(Step 2B/33) performed" + "; build2program4xi-performed-by-build2program-of-Program4Xi: " + str(build2program4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-build2program-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "compile2program-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO COMPILE PROGRAM FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4compile2program = {} 
    #        for key2pu in keys2pu:
    #            task4compile2program [key2pu]  = {}
    #                        
    #        response4compile2program = p2xi.compile2program(task4compile2program)                                  
    #        
    #        keys2response = response4compile2program.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4compile2program[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO COMPILE PROGRAM FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def compile2program(self, task4compile2program = None):
        '''
        compiles program for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "compile2program"
                     
        message2print = "{(Step 1A/33) started" + "; compile2program-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4compile2program-passed-to-set-of-Program4Xi: " + str(task4compile2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4compile2program-passing-to-compile2program4xi-by-compile2program-of-Program4Xi: " + str(task4compile2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = compile2program4xi(task4compile2program)

        message2print = "{(Step 2B/33) performed" + "; compile2program4xi-performed-by-compile2program-of-Program4Xi: " + str(compile2program4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-compile2program-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2programwithsource-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM WITH SOURCE FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4create2programwithsource = {} 
    #        for key2pu in keys2pu:
    #            task4create2programwithsource [key2pu]  = {}
    #                        
    #        response4create2programwithsource = p2xi.create2programwithsource(task4create2programwithsource)                                  
    #        
    #        keys2response = response4create2programwithsource.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4create2programwithsource[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM WITH SOURCE FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2programwithsource(self, task4create2programwithsource = None):
        '''
        creates program with source for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "create2programwithsource"
                     
        message2print = "{(Step 1A/33) started" + "; create2programwithsource-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4create2programwithsource-passed-to-create-of-Program4Xi: " + str(task4create2programwithsource) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2programwithsource-passing-to-create2programwithsource4xi-by-create2programwithsource-of-Program4Xi: " + str(task4create2programwithsource) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = create2programwithsource4xi(task4create2programwithsource)

        message2print = "{(Step 2B/33) performed" + "; create2programwithsource4xi-performed-by-create2programwithsource-of-Program4Xi: " + str(create2programwithsource4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-create2programwithsource-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2programwithbinary-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO CREATE PROGRAM WITH BINARY FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4create2programwithbinary = {} 
    #        for key2pu in keys2pu:
    #            task4create2programwithbinary [key2pu]  = {}
    #                        
    #        response4create2programwithbinary = p2xi.create2programwithbinary(task4create2programwithbinary)                                  
    #        
    #        keys2response = response4create2programwithbinary.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4create2programwithbinary[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO CREATE PROGRAM WITH BINARY FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2programwithbinary(self, task4create2programwithbinary = None):
        '''
        creates program with binary for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "create2programwithbinary"
                     
        message2print = "{(Step 1A/33) started" + "; create2programwithbinary-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4create2programwithbinary-passed-to-create-of-Program4Xi: " + str(task4create2programwithbinary) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2programwithbinary-passing-to-create2programwithbinary4xi-by-create2programwithbinary-of-Program4Xi: " + str(task4create2programwithbinary) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = create2programwithbinary4xi(task4create2programwithbinary)

        message2print = "{(Step 2B/33) performed" + "; create2programwithbinary4xi-performed-by-create2programwithbinary-of-Program4Xi: " + str(create2programwithbinary4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-create2programwithbinary-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2programwithbinary-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO SET PROGRAM WITH BINARY FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4set2programwithbinary = {} 
    #        for key2pu in keys2pu:
    #            task4set2programwithbinary [key2pu]  = {}
    #                        
    #        response4set2programwithbinary = p2xi.set2programwithbinary(task4set2programwithbinary)                                  
    #        
    #        keys2response = response4set2programwithbinary.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4set2programwithbinary[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO SET PROGRAM WITH BINARY FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def set2programwithbinary(self, task4set2programwithbinary = None):
        '''
        sets program with binary for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "set2programwithbinary"
                     
        message2print = "{(Step 1A/33) started" + "; set2programwithbinary-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2programwithbinary-passed-to-set-of-Program4Xi: " + str(task4set2programwithbinary) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2programwithbinary-passing-to-set2programwithbinary4xi-by-set2programwithbinary-of-Program4Xi: " + str(task4set2programwithbinary) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = set2programwithbinary4xi(task4set2programwithbinary)

        message2print = "{(Step 2B/33) performed" + "; set2programwithbinary4xi-performed-by-set2programwithbinary-of-Program4Xi: " + str(set2programwithbinary4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-set2programwithbinary-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2programwithsource-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO SET PROGRAM WITH SOURCE FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4set2programwithsource = {} 
    #        for key2pu in keys2pu:
    #            task4set2programwithsource [key2pu]  = {}
    #                        
    #        response4set2programwithsource = p2xi.set2programwithsource(task4set2programwithsource)                                  
    #        
    #        keys2response = response4set2programwithsource.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4set2programwithsource[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO SET PROGRAM WITH SOURCE FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def set2programwithsource(self, task4set2programwithsource = None):
        '''
        sets program with source for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "set2programwithsource"
                     
        message2print = "{(Step 1A/33) started" + "; set2programwithsource-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2programwithsource-passed-to-set-of-Program4Xi: " + str(task4set2programwithsource) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2programwithsource-passing-to-set2programwithsource4xi-by-set2programwithsource-of-Program4Xi: " + str(task4set2programwithsource) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = set2programwithsource4xi(task4set2programwithsource)

        message2print = "{(Step 2B/33) performed" + "; set2programwithsource4xi-performed-by-set2programwithsource-of-Program4Xi: " + str(set2programwithsource4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-set2programwithsource-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2programwithsource-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO ADD PROGRAM WITH SOURCE FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4add2programwithsource = {} 
    #        for key2pu in keys2pu:
    #            task4add2programwithsource [key2pu]  = {}
    #                        
    #        response4add2programwithsource = p2xi.add2programwithsource(task4add2programwithsource)                                  
    #        
    #        keys2response = response4add2programwithsource.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4add2programwithsource[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO ADD PROGRAM WITH SOURCE FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def add2programwithsource(self, task4add2programwithsource = None):
        '''
        add program with source for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "add2programwithsource"
                     
        message2print = "{(Step 1A/33) started" + "; add2programwithsource-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2programwithsource-passed-to-set-of-Program4Xi: " + str(task4add2programwithsource) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2programwithsource-passing-to-add2programwithsource4xi-by-add2programwithsource-of-Program4Xi: " + str(task4add2programwithsource) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = add2programwithsource4xi(task4add2programwithsource)

        message2print = "{(Step 2B/33) performed" + "; add2programwithsource4xi-performed-by-add2programwithsource-of-Program4Xi: " + str(add2programwithsource4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-add2programwithsource-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2programwithbinary-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO ADD PROGRAM WITH BINARY FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4add2pwb = {} 
    #        for key2pu in keys2pu:
    #            task4add2pwb [key2pu]  = {}
    #                        
    #        response4add2pwb = p2xi.add2programwithbinary(task4add2pwb)                                  
    #        
    #        keys2response = response4add2pwb.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4add2pwb[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO ADD PROGRAM WITH BINARY FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def add2programwithbinary(self, task4add2pwb = None):
        '''
        add program with binary for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "add2programwithbinary"
                     
        message2print = "{(Step 1A/33) started" + "; add2programwithbinary-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2pwb-passed-to-set-of-Program4Xi: " + str(task4add2pwb) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2pwb-passing-to-add2programwithbinary4xi-by-add2programwithbinary-of-Program4Xi: " + str(task4add2pwb) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
        response4add2pwb = None
        try:
            response4add2pwb = add2programwithbinary4xi(task4add2pwb)
            
            message2print = "{(Step 2B/33) performed" + "; add2programwithbinary4xi-performed-by-add2programwithbinary-of-Program4Xi: " + str(add2programwithbinary4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        except:
            message2print = "{(Step 2Z/33) hit" + "; task4add2pwb-hit-by-add2programwithbinary4xi-of-Program4Xi: " + " *** " + str(task4add2pwb)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     

        message2print = "{(Step 2B/33) performed" + "; add2programwithbinary4xi-performed-by-add2programwithbinary-of-Program4Xi: " + str(add2programwithbinary4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; response4add2pwb-returning-by-add2programwithbinary-of-Program4Xi: " + str(response4add2pwb) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        return response4add2pwb
                                
                    
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2programwithbinary-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO DELETE PROGRAM WITH BINARY FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4delete2pwb = {} 
    #        for key2pu in keys2pu:
    #            task4delete2pwb [key2pu]  = {}
    #                        
    #        response4delete2pwb = p2xi.delete2programwithbinary(task4delete2pwb)                                  
    #        
    #        keys2response = response4delete2pwb.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4delete2pwb[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO DELETE PROGRAM WITH BINARY FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def delete2programwithbinary(self, task4delete2pwb = None):
        '''
        delete program with binary for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "delete2programwithbinary"
                     
        message2print = "{(Step 1A/33) started" + "; delete2programwithbinary-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2pwb-passed-to-set-of-Program4Xi: " + str(task4delete2pwb) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2pwb-passing-to-delete2programwithbinary4xi-by-delete2programwithbinary-of-Program4Xi: " + str(task4delete2pwb) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
        response4delete2pwb = None
        try:
            response4delete2pwb = delete2programwithbinary4xi(task4delete2pwb)
            
            message2print = "{(Step 2B/33) performed" + "; delete2programwithbinary4xi-performed-by-delete2programwithbinary-of-Program4Xi: " + str(delete2programwithbinary4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        except:
            message2print = "{(Step 2Z/33) hit" + "; task4delete2pwb-hit-by-delete2programwithbinary4xi-of-Program4Xi: " + " *** " + str(task4delete2pwb)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     

        message2print = "{(Step 2B/33) performed" + "; delete2programwithbinary4xi-performed-by-delete2programwithbinary-of-Program4Xi: " + str(delete2programwithbinary4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; response4delete2pwb-returning-by-delete2programwithbinary-of-Program4Xi: " + str(response4delete2pwb) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        return response4delete2pwb
                                
                    
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2programwithsource-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO DELETE PROGRAM WITH SOURCE FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4delete2programwithsource = {} 
    #        for key2pu in keys2pu:
    #            task4delete2programwithsource [key2pu]  = {}
    #                        
    #        response4delete2programwithsource = p2xi.delete2programwithsource(task4delete2programwithsource)                                  
    #        
    #        keys2response = response4delete2programwithsource.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4delete2programwithsource[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO DELETE PROGRAM WITH SOURCE FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def delete2programwithsource(self, task4delete2programwithsource = None):
        '''
        deletes program with source for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "delete2programwithsource"
                     
        message2print = "{(Step 1A/33) started" + "; delete2programwithsource-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2programwithsource-passed-to-set-of-Program4Xi: " + str(task4delete2programwithsource) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2programwithsource-passing-to-delete2programwithsource4xi-by-delete2programwithsource-of-Program4Xi: " + str(task4delete2programwithsource) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = delete2programwithsource4xi(task4delete2programwithsource)

        message2print = "{(Step 2B/33) performed" + "; delete2programwithsource4xi-performed-by-delete2programwithsource-of-Program4Xi: " + str(delete2programwithsource4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-delete2programwithsource-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2programinfo-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO GET PROGRAM INFO FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4get2programinfo = {} 
    #        for key2pu in keys2pu:
    #            task4get2programinfo [key2pu]  = {}
    #                        
    #        response4get2programinfo = p2xi.get2programinfo(task4get2programinfo)                                  
    #        
    #        keys2response = response4get2programinfo.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4get2programinfo[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO GET PROGRAM INFO FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2programinfo(self, task4get2programinfo = None):
        '''
        deletes program with source for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "get2programinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2programinfo-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4get2programinfo-passed-to-set-of-Program4Xi: " + str(task4get2programinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4get2programinfo-passing-to-get2programinfo4xi-by-get2programinfo-of-Program4Xi: " + str(task4get2programinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = get2programinfo4xi(task4get2programinfo)

        message2print = "{(Step 2B/33) performed" + "; get2programinfo4xi-performed-by-get2programinfo-of-Program4Xi: " + str(get2programinfo4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-get2programinfo-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "link2program-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO LINK PROGRAM FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4link2program = {} 
    #        for key2pu in keys2pu:
    #            task4link2program [key2pu]  = {}
    #                        
    #        response4link2program = p2xi.link2program(task4link2program)                                  
    #        
    #        keys2response = response4link2program.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4link2program[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO LINK PROGRAM FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def link2program(self, task4link2program = None):
        '''
        links program for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "link2program"
                     
        message2print = "{(Step 1A/33) started" + "; link2program-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4link2program-passed-to-set-of-Program4Xi: " + str(task4link2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4link2program-passing-to-link2program4xi-by-link2program-of-Program4Xi: " + str(task4link2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = link2program4xi(task4link2program)

        message2print = "{(Step 2B/33) performed" + "; link2program4xi-performed-by-link2program-of-Program4Xi: " + str(link2program4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-link2program-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2program-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO RELEASE PROGRAM FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4release2program = {} 
    #        for key2pu in keys2pu:
    #            task4release2program [key2pu]  = {}
    #                        
    #        response4release2program = p2xi.release2program(task4release2program)                                  
    #        
    #        keys2response = response4release2program.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4release2program[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO RELEASE PROGRAM FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def release2program(self, task4release2program = None):
        '''
        releases program for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "release2program"
                     
        message2print = "{(Step 1A/33) started" + "; release2program-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2program-passed-to-set-of-Program4Xi: " + str(task4release2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2program-passing-to-release2program4xi-by-release2program-of-Program4Xi: " + str(task4release2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = release2program4xi(task4release2program)

        message2print = "{(Step 2B/33) performed" + "; release2program4xi-performed-by-release2program-of-Program4Xi: " + str(release2program4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-release2program-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2program-of-Program4Xi" usage = "
    #    print('(Step 123A/700) OF PROGRAM4XI5TEST - TRYING TO RETAIN PROGRAM FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Program4Xi()                            
    #        
    #        task4retain2program = {} 
    #        for key2pu in keys2pu:
    #            task4retain2program [key2pu]  = {}
    #                        
    #        response4retain2program = p2xi.retain2program(task4retain2program)                                  
    #        
    #        keys2response = response4retain2program.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4retain2program[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF PROGRAM4XI5TEST *** FAILED TO RETAIN PROGRAM FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def retain2program(self, task4retain2program = None):
        '''
        retains program for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "retain2program"
                     
        message2print = "{(Step 1A/33) started" + "; retain2program-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2program-passed-to-set-of-Program4Xi: " + str(task4retain2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2program-passing-to-retain2program4xi-by-retain2program-of-Program4Xi: " + str(task4retain2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        program2xi = retain2program4xi(task4retain2program)

        message2print = "{(Step 2B/33) performed" + "; retain2program4xi-performed-by-retain2program-of-Program4Xi: " + str(retain2program4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; program2xi-returning-by-retain2program-of-Program4Xi: " + str(program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return program2xi
                                
    #                        
    #</methodize4xi>
    

                  
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2program-of-Program4Xi" usage = "
    #
    #    print('(Step 125A/25) OF PROGRAM4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
    #    try:                               
    #        task4trace2program  = {}
    #        for key2pu in keys2pu:
    #            task4trace2program[key2pu]  = {}
    #            
    #        response4trace2program = p2xi.trace2program(task4trace2program) 
    #        
    #        key2response = response4trace2program.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4trace2program[key2response] )
    #            # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4apu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4apu', 'METHOD': 'trace2program4apu'}
    #            # BPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4bpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4bpu', 'METHOD': 'trace2program4bpu'}
    #            # CPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4cpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4cpu', 'METHOD': 'trace2program4cpu'}
    #            # DPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4dpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4dpu', 'METHOD': 'trace2program4dpu'}
    #            # EPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4epu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4epu', 'METHOD': 'trace2program4epu'}
    #            # FPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4fpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4fpu', 'METHOD': 'trace2program4fpu'}
    #            # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4gpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4gpu', 'METHOD': 'trace2program4gpu'}
    #            # HPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4hpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4hpu', 'METHOD': 'trace2program4hpu'}
    #            # IPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4ipu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4ipu', 'METHOD': 'trace2program4ipu'}
    #            # JPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4jpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4jpu', 'METHOD': 'trace2program4jpu'}
    #            # KPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4kpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4kpu', 'METHOD': 'trace2program4kpu'}
    #            # LPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4lpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4lpu', 'METHOD': 'trace2program4lpu'}
    #            # MPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4mpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4mpu', 'METHOD': 'trace2program4mpu'}
    #            # NPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4npu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4npu', 'METHOD': 'trace2program4npu'}
    #            # OPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4opu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4opu', 'METHOD': 'trace2program4opu'}
    #            # PPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4ppu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4ppu', 'METHOD': 'trace2program4ppu'}
    #            # QPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4qpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4qpu', 'METHOD': 'trace2program4qpu'}
    #            # RPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4rpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4rpu', 'METHOD': 'trace2program4rpu'}
    #            # SPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4spu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4spu', 'METHOD': 'trace2program4spu'}
    #            # TPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4tpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4tpu', 'METHOD': 'trace2program4tpu'}
    #            # UPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4upu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4upu', 'METHOD': 'trace2program4upu'}
    #            # VPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4vpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4vpu', 'METHOD': 'trace2program4vpu'}
    #            # WPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4wpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4wpu', 'METHOD': 'trace2program4wpu'}
    #            # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4xpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4xpu', 'METHOD': 'trace2program4xpu'}
    #            # YPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4ypu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4ypu', 'METHOD': 'trace2program4ypu'}
    #            # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2program4zpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2program4zpu', 'METHOD': 'trace2program4zpu'}
    #                                                                                                       
    #    except:
    #        print('(Step 125Z/25) OF PROGRAM4XI5TEST *** FAILED TO TRACE XI: ', time4xi())       
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2program(self, task4trace2program = None):
        '''
        traces Program4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "trace2program"
                     
        message2print = "{(Step 1A/33) started" + "; trace2program-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2program-passed-to-trace-of-Program4Xi: " + str(task4trace2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #    
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2program-passing-to-trace2program4xi-by-trace2program-of-Program4Xi: " + str(task4trace2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        trace2xi = trace2program4xi(task4trace2program)

        message2print = "{(Step 2B/33) performed" + "; trace2program4xi-performed-by-trace2program-of-Program4Xi: " + str(trace2program4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2program-of-Program4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                 
                
        return trace2xi
                                                           
    #</methodize4xi>       


    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2programcallback-of-Program4Xi" usage = "
    # 
    #    print('(Step 124A/700) OF PROGRAM4XI5TEST - TRYING TO SET PROGRAM CALLBACK WITH METHOD OF OBJECT XI2XI: ', p2xi) 
    # 
    #    try:
    #        task4callback2program = {} 
    #        for key2pu in keys2pu:
    #            task4callback2program [key2pu]  = {}
    #                                         
    #        response4callback = p2xi.set2programcallback(task4callback2program)                                  
    #        
    #        key2response = response4callback.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4callback [key2response] )
    #            # APU  :  {'CALLBACK': <function trace2program4apu at 0x00000000043E2648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # BPU  :  {'CALLBACK': <function trace2program4bpu at 0x00000000044C40C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # CPU  :  {'CALLBACK': <function trace2program4cpu at 0x0000000004581848>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # DPU  :  {'CALLBACK': <function trace2program4dpu at 0x00000000046AD048>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # EPU  :  {'CALLBACK': <function trace2program4epu at 0x00000000047667C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # FPU  :  {'CALLBACK': <function trace2program4fpu at 0x000000000483AF48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # GPU  :  {'CALLBACK': <function trace2program4gpu at 0x0000000004914748>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # HPU  :  {'CALLBACK': <function trace2program4hpu at 0x00000000049B0EC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # IPU  :  {'CALLBACK': <function trace2program4ipu at 0x0000000004A8F6C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # JPU  :  {'CALLBACK': <function trace2program4jpu at 0x0000000004B19E48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # KPU  :  {'CALLBACK': <function trace2program4kpu at 0x0000000004C00648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # LPU  :  {'CALLBACK': <function trace2program4lpu at 0x0000000004CC4DC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # MPU  :  {'CALLBACK': <function trace2program4mpu at 0x0000000004DA55C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # NPU  :  {'CALLBACK': <function trace2program4npu at 0x0000000004E47D48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # OPU  :  {'CALLBACK': <function trace2program4opu at 0x0000000004F4B548>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # PPU  :  {'CALLBACK': <function trace2program4ppu at 0x0000000004FDDCC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # QPU  :  {'CALLBACK': <function trace2program4qpu at 0x00000000051034C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # RPU  :  {'CALLBACK': <function trace2program4rpu at 0x0000000005248C48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # SPU  :  {'CALLBACK': <function trace2program4spu at 0x0000000005337448>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # TPU  :  {'CALLBACK': <function trace2program4tpu at 0x00000000053F7BC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # UPU  :  {'CALLBACK': <function trace2program4upu at 0x00000000054A23C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # VPU  :  {'CALLBACK': <function trace2program4vpu at 0x0000000005537B48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # WPU  :  {'CALLBACK': <function trace2program4wpu at 0x00000000056AAAC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # XPU  :  {'CALLBACK': <function trace2program4xpu at 0x0000000005628348>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # YPU  :  {'CALLBACK': <function trace2program4ypu at 0x00000000057572C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # ZPU  :  {'CALLBACK': <function trace2program4zpu at 0x0000000005854A48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #                          
    #    except:
    #        print('(Step 124Z/700) OF PROGRAM4XI5TEST *** FAILED TO SET PROGRAM CALLBACK WITH METHOD ***', time4xi())    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2programcallback(self, task4set2programcallback = None): 
        '''
        set2programcallback of Program4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Program4Xi"
        method2print = "set2programcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2programcallback-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2programcallback-passed-to-set2programcallback-of-Program4Xi: " + str(task4set2programcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None    
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2programcallback-passing-to-set2programcallback -by-set2programcallback-of-Program4Xi: " + str(task4set2programcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        callback2xi4program = {} 
        try:
            callback2xi4program = set2programcallback4xi (task4set2programcallback)

            message2print = "{(Step 2B/33) callback2xi4program" + "; callback2xi4program-set-by-set2programcallback-of-Program4Xi to: " + str(callback2xi4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # 
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2xi4program-failed-by-set2programcallback-of-Program4Xi: " + str(callback2xi4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2xi4program-returning-by-set2programcallback-of-Program4Xi: " + str(callback2xi4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                                             
        return callback2xi4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Program4Xi" usage = "
    #
    #    print('(Step 170A/700) OF PROGRAM4XI5TEST - SENSING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4sense = p2xi.sense()
    #         
    #         print(response4sense)
    #         # {'classvariable2xi-of-Program4Xi': 4, 'object': <program4xi.Program4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 170Z/700) OF PROGRAM4XI5TEST *** FAILED TO SENSE ', time4xi())      
    #  
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Program4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Program4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; Program4Xi-sensing-by-sense-of-Program4Xi: " + str(Program4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-Program4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2xi-of-Program4Xi'] = Program4Xi.classvariable2xi
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-Program4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; Program4Xi-sensed-by-sense-of-Program4Xi: " + str(Program4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-Program4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Program4Xi" usage = "
    # 
    #    print('(Step 171A/700) OF PROGRAM4XI5TEST - REASONING ', time4xi())  
    #    # 
    #    try:
    #                
    #        response4reason = p2xi.reason()
    #        
    #        print(response4reason)
    #        # {'object-reason-object4xi': <program4xi.Program4Xi object at 0x0000000006018278>, 'time-reason-of-Program4Xi': '09:46:11 11/05/11 Pacific Daylight Time'}         
    # 
    #     except:
    #         print('(Step 171Z/700) OF PROGRAM4XI5TEST *** FAILED TO REASON ', time4xi())  
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Program4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Program4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; Program4Xi-reasoning-by-reason-of-Program4Xi: " + str(Program4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Program4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Program4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Program4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; Program4Xi-reasoned-by-reason-of-Program4Xi: " + str(Program4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Program4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #            
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Program4Xi" usage = "
    # 
    #    print('(Step 172A/700) OF PROGRAM4XI5TEST - ACING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4ace = p2xi.ace()
    # 
    #         print(response4ace)
    #         # {'cores-of-Program4Xi': 4, 'object8xi': <program4xi.Program4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 172Z/700) OF PROGRAM4XI5TEST *** FAILED TO ACE ', time4xi())                                     
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Program4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Program4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-Program4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; Program4Xi-acing-by-ace-of-Program4Xi: " + str(Program4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #         
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Program4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-Program4Xi'] = Program4Xi.classvariable2xi
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Program4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; Program4Xi-aced-by-ace-of-Program4Xi: " + str(Program4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Program4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   program4xi5test.txt
#   sense-program4xi5test.xml
#   reason-program4xi5test.xml
#   ace-program4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of program4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
